<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Event;
use DB;
use Input;
use Cookie;
use App\log_logins as log_login;
use App\employees as employee;
use App\customers as customer;
use phpDocumentor\Reflection\Types\This;

use getClientIps;

class AuthorizationController extends Controller
{

    public function index()
    {
        $this->get_configuration();
        return view('Authorization.login', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories()
        ]);
    }

    public function Signout()
    {
        // Delete Cookie
        session()->flush();
        session()->regenerate();

        Cookie::queue(Cookie::forget('customer_id'));
        Cookie::queue(Cookie::forget('customer_name'));
        Cookie::queue(Cookie::forget('customer_email'));
        Cookie::queue(Cookie::forget('customer_password'));
        Cookie::queue(Cookie::forget('customer_birthday'));
        Cookie::queue(Cookie::forget('customer_gender'));
        Cookie::queue(Cookie::forget('customer_mobile'));
        Cookie::queue(Cookie::forget('Lifetime_Front_cookies'));

        return redirect()->route('index.index')->with('success', 'Good Luck');
    }

    public function create()
    {
        //
    }


    function get_client_ip()
    {
        $ipaddress = '';
        if (isset($_SERVER['HTTP_CLIENT_IP']))
            $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
        else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_X_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
        else if (isset($_SERVER['HTTP_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_FORWARDED'];
        else if (isset($_SERVER['REMOTE_ADDR']))
            $ipaddress = $_SERVER['REMOTE_ADDR'];
        else
            $ipaddress = 'UNKNOWN';
        return $ipaddress;
    }

    private function SaveLog()
    {
        //$clientIP = request()->ip();
        $log_logins = new log_login([
            'ip' => $this::get_client_ip(),
            'email' => $this->email,
            'password' => $this->password,
            'status' => $this->status,
            'description' => $this->description
        ]);
        $log_logins->save();
    }

    public function SaveCookie()
    {


        $this->Lifetime_Front_cookies    = $this->get_configuration_by_name('Lifetime_Front_cookies')*1140;  // 1 วัน = 60 * 24

        Cookie::queue('customer_id', $this->customer_id,     $this->Lifetime_Front_cookies);
        Cookie::queue('customer_type', $this->customer_type, $this->Lifetime_Front_cookies);
        Cookie::queue('customer_name', $this->flname,        $this->Lifetime_Front_cookies);
        Cookie::queue('customer_email', $this->email,        $this->Lifetime_Front_cookies);
        Cookie::queue('customer_password', $this->password,  $this->Lifetime_Front_cookies);
        Cookie::queue('customer_password', $this->password,  $this->Lifetime_Front_cookies);
        Cookie::queue('customer_birthday', $this->birthday,  $this->Lifetime_Front_cookies);
        Cookie::queue('customer_gender', $this->gender,      $this->Lifetime_Front_cookies);
        Cookie::queue('customer_mobile', $this->mobile,      $this->Lifetime_Front_cookies);

        ////////////////////////////////////////////////
        //Store items in session
        ////////////////////////////////////////////////
        session(['session_customer_id' => $this->customer_id, 'session_customer_name'=> $this->flname]);
        session(['session_customer_email' => $this->email, 'session_customer_type' => $this->customer_type]);

        //dd($this->customer_type);


    }


    public function store(Request $request)
    {
        $this->validate(
            $request,
            [
                'email' => 'required',
                'password' => 'required|min:6'

            ],
            [
                'email.required' => 'กรุณาระบุ Email เพื่อใช้ในการเข้าระบบ',
                'email.unique' => 'กรุณาระบุ Email ให้ถูกต้อง',
                'password.required' => 'กรุณาระบุ Password',
                'password.min' => 'กรุณาระบุ Email ตามรูปแบบที่ถูกต้อง '
            ]
        );



        $this->email    = $request->get('email');
        $this->password = $request->get('password');
        $customer = customer::where('email', '=', $request->get('email'))
            ->where('password', '=', $request->get('password'))
            ->get();

        if (count($customer) > 0) {
            foreach ($customer as $user) {
                $this->customer_id = $user->id;
                $this->customer_type = $user->customer_type;
                $this->gender = $user->gender;
                $this->flname = $user->flname;
                $this->mobile = $user->mobile;

                $email_confirm_id = $user->email_confirm_id;
                $email_confirm = $user->email_confirm;
                $this->birthday = $user->birthday;

                //dd( $this->customer_type);
            }
            $this->status = 1;

            if (($email_confirm == 'YES') || ($email_confirm == 'NO')){
                $this->status = 1;
                $this->description='ปกติ';
                self::SaveLog();
                self::SaveCookie();
                return redirect()->route('index.index')->with('success', 'ยินดีต้อนรับ');
            }

        } else {
            $this->status = 0;
            $this->description = 'รหัสผ่านไม่ถูกต้อง';
            self::SaveLog();
            return redirect()->route('Authorization.index')->with('fail', 'Email หรือ รหัสผ่านไม่ถูกต้อง ! กรุณาลองใหม่ (A)');
        }
    }

    public function show($id)
    {
        //
    }


    public function edit($id)
    {
        //
    }

    public function update(Request $request, $id)
    {
        //
    }

    public function destroy($id)
    {
        //
    }
}
