<?php

namespace App\Http\Controllers;

use Carbon\Carbon;

use Illuminate\Http\Request;
use Illuminate\Auth\Events\Failed;
use DB;
use Cookie;
use Session;
use App\employees as employee;
use App\customers as customer;
use App\configurations as configurations;
use App\products_categories as categorie;
use App\products_likes as products_like;
use App\products as product;
use App\log_logins as log_login;
use App\pr as pr;
use App\po_master as po_master;
use App\po_items as po_items;

use App\pictures as picture;

use Illuminate\Support\Facades\Mail;
use App\Mail\Order_Confirmed2;

// use Illuminate\Support\Facades\Storage;
// use Illuminate\Support\Facades\File;
// use Illuminate\Http\UploadedFile;

class CartController extends Controller
{

    public function Add_Cart(Request $request)
    {
        // ตรวจ คน
        $customer_id = $request->get('ID_customer');
        if ($customer_id != '') {

            $product_color = $request->get('product_color');
            if ($product_color == '') {
                $product_color = 'NA';
            }

            // ตรวจว่าเคยสั่งรายการนี้ไหม
            $chk_Quantity = pr::where('ID_customer', '=', $customer_id)
                ->where('ID_product', '=', $request->get('ID_product'))
                ->where('product_color', '=', $product_color)
                ->get();

            $has_old_data = false;
            $old_Quantity = 0;
            if (count($chk_Quantity) > 0) {
                foreach ($chk_Quantity as $data) {
                    $old_Quantity = $data->Quantity;
                    $ID_pr = $data->id;
                }
                $has_old_data = true;
            }
            $sum_Quantity = $old_Quantity + $request->get('quantity_input');

            if ($sum_Quantity<1) {      // ป้องกันกรณีสั้่งสินค้า  O ชิ้น
                $sum_Quantity=1;
            }

            if ($has_old_data) {
                // Update
                $new_pr = pr::find($ID_pr);
                $new_pr->Quantity = $sum_Quantity;
                $new_pr->save();
            } else {
                // จะไม่พูดถึงราคาที่นี่
                $new_pr = new pr([
                    'Customer_Select' => 'ON',
                    'ID_customer' => $customer_id,
                    'ID_product' => $request->ID_product,
                    'product_color' => $product_color,
                    'Quantity' => $sum_Quantity,
                    'ip' => $this->get_client_ipmain()
                ]);
                $new_pr->save();
            }

            ////////////////////////////////////////////////
            //Store items in session
            ////////////////////////////////////////////////
            // session(['ID_product_NOW' => $request->ID_product]);
            // session(['product_color_NOW' => $product_color]);
            // session(['Quantity_NOW' => $sum_Quantity]);
            // session(['path_pic_NOW' => $customer_id]);
        } else {
            // เรียก Login Modal :::
        }
    }

    public function index()
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type = Cookie::get('customer_type');
        }else {
          $CookieID_customer = 0;
          $customer_type = "retail";
          return redirect()->route('index')->with('fail', 'Email หรือ รหัสผ่านไม่ถูกต้อง ! กรุณาลองใหม่ (A)');

        }

        // if ($customer_type=="retail"){

          return view('Cart.Cart_create_retail', [
              'sess_grandparent_categories' => $this->grandparent_categories(),
              'sess_sub_categories' => $this->sub_categories(),
              'sess_categorie' => $this->sub_concat_categories(),
              'sess_categorie_short' => $this->categories(),
              'product_list20' => $this->categories(),
              'arr_configuration' => $this->get_configuration(),
              'pr_list' => $this->get_pr_list($customer_type, $CookieID_customer),
              'ID_customer' => $CookieID_customer,
              'po_mastermain' => $this->get_po_master($CookieID_customer)
           ]);

        // } else if (( $customer_type=="wholesale") || ($customer_type=="salesman")){
        //
        //   return view('Cart.Cart_create_wholesale', [
        //       'sess_grandparent_categories' => $this->grandparent_categories(),
        //       'sess_sub_categories' => $this->sub_categories(),
        //       'sess_categorie' => $this->sub_concat_categories(),
        //       'sess_categorie_short' => $this->categories(),
        //       'product_list20' => $this->categories(),
        //       'arr_configuration' => $this->get_configuration(),
        //       'pr_list' => $this->get_pr_list($customer_type, $CookieID_customer),
        //       'ID_customer' => $CookieID_customer,
        //       'po_mastermain' => $this->get_po_master($CookieID_customer)
        //    ]);
        //
        // }
    }

    public function create()
    {
       // dd("Cart Controller create");
    }

    public function Create_PO(Request $request)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type = "retail";
        }

        // 1. Delete PO และ po_items ของคนนี้ที่เป็น PO_ID = 0 : เครีร์ยรายการเก่า เผื่อว่ามีการทำนรายการที่ไม่จบค้างไว้ ให้เริ่มใหม่
        DB::table('po_masters')
            ->where('ID_customer', '=', $CookieID_customer)
            ->where('PO_Number', '=', '0')
            ->delete();

        DB::table('po_items')
            ->where('ID_customer', '=', $CookieID_customer)
            ->where('PO_Number', '=', '0')
            ->delete();

        // 2.1 Copy prs --> PO & po_items
        //    Set ID_PO ยังเป็น 0
        if ($customer_type=="retail"){

            $Copy_prs = DB::insert("
                INSERT INTO po_items(PO_Number, ID_product, product_color, ID_customer, product_name_th, shipping_weight,
                Quantity, product_unit, final_price,total)

                SELECT
                    PR.ID_PO, PR.ID_product ,PR.product_color, PR.ID_customer, PD.product_name_th, PD.shipping_weight,
                    PR.Quantity, PD.product_unit,

                CASE
                    WHEN   retail_discount_dateStart <= now()
                    and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   retail_price - retail_discount
                    ELSE   retail_price
                END AS   retail_update_final_price,
                (CASE
                    WHEN   retail_discount_dateStart <= now()
                    and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   retail_price - retail_discount
                    ELSE   retail_price
                END) * PR.Quantity as total

                FROM prs PR, products PD
                where PR.ID_product = PD.id
                and  PR.ID_customer = $CookieID_customer
                and  PR.ID_PO=0
                and  PR.Customer_Select='ON'
            ");

        }else if (( $customer_type=="wholesale") || ($customer_type=="salesman")){
            //////////////////////////////////////////////////////////
            // ใช้ราคา จาก prs ที่ลูกค้า แก้ไขมา เท่านั้น
            /////////////////////////////////////////////////////////
            $Copy_prs = DB::insert("
                INSERT INTO po_items(PO_Number, ID_product, product_color, ID_customer, product_name_th, shipping_weight,
                Quantity, product_unit, final_price,total)

                SELECT
                    PR.ID_PO, PR.ID_product ,PR.product_color, PR.ID_customer, PD.product_name_th, PD.shipping_weight,
                    PR.Quantity, PD.product_unit,

                CASE
                    WHEN   wholesale_discount_dateStart <= now()
                    and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   wholesale_price - wholesale_discount
                    ELSE   wholesale_price
                END AS   wholesale_update_final_price,
                (CASE
                    WHEN   wholesale_discount_dateStart <= now()
                    and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   wholesale_price - wholesale_discount
                    ELSE   wholesale_price
                END) * PR.Quantity as total

                FROM prs PR, products PD
                where PR.ID_product = PD.id
                and  PR.ID_customer = $CookieID_customer
                and  PR.ID_PO=0
                and  PR.Customer_Select='ON'
            ");

        }

        $this->read_delivery_configuration($CookieID_customer, 'po_items');
        // $this->sum_weight;  /
        // $this->sum_total;  /
        // $this->delivery_NormalPrice_final; /
        // $this->delivery_rate_normal_time;  /

        // $this->delivery_SpecialPrice_final;  x
        // $this->delivery_rate_special_time;   x
        // return ----> $this->count_Quantity
        //echo " <br> delivery_NormalPrice_final " . $this->delivery_NormalPrice_final;
        //echo " <br> delivery_SpecialPrice_final " . $this->delivery_SpecialPrice_final;

        // 2.7 หารายละเอียดของลูกค้า
        $customers = DB::select("
            SELECT  id , email , flname , customer_type , customer_tag , mobile , fax , payment_type , shipping_type ,
            company , company_tag , billing_flname , billing_address , billing_city , billing_province , billing_zipcode ,
            billing_telephone , shipping_flname , shipping_address , shipping_city , shipping_province , shipping_zipcode ,
            shipping_telephone
            FROM  customers
            WHERE id = $CookieID_customer
        ");
        foreach ($customers as $customers) {
            // 3 สร้าง PO
            $delivery_from = now()->addDays($this->delivery_rate_normal_time - 4);
            $delivery_end = now()->addDays($this->delivery_rate_normal_time);

            $po_shipping_charge = $this->delivery_NormalPrice_final;
            $po_grandtotal = $this->sum_total + $po_shipping_charge;

            $new_po = new po_master([
                'PO_Number' => '0',
                'ID_customer' => $CookieID_customer,
                'PO_date' => now(),
                'delivery_from' => $delivery_from,
                'delivery_end' => $delivery_end,
                'payment' => $customers->payment_type,
                //'payment_image' => $sum_Quantity,
                'shipping_type' => 'แบบธรรมดา',
                'mobile' => $customers->mobile,
                'company' => $customers->company,
                'ID_tag' => $customers->company_tag,

                'billing_flname' => $customers->billing_flname,
                //'billing_email' => $customers->email,
                'billing_address' => $customers->billing_address,
                'billing_city' => $customers->billing_city,
                'billing_province' => $customers->billing_province,
                'billing_zipcode' => $customers->billing_zipcode,
                'billing_telephone' => $customers->billing_telephone,

                'shipping_flname' => $customers->shipping_flname,
                //'shipping_email' => $customers->email,
                'shipping_address' => $customers->shipping_address,
                'shipping_city' => $customers->shipping_city,
                'shipping_province' => $customers->shipping_province,
                'shipping_zipcode' => $customers->shipping_zipcode,
                'shipping_telephone' => $customers->shipping_telephone,

                'weight' => $this->sum_weight,
                'total' => $this->sum_total,
                'Quantity' => $this->count_Quantity,
                'po_shipping_charge' => $po_shipping_charge,
                'po_grandtotal' => $po_grandtotal,

                'po_status' => '1'
            ]);
            $new_po->save();
        }

        // 3. Show PO
        $po_master = DB::select("

            SELECT PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                CUS.customer_type, CUS.payment_type, CUS.email

            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.ID_customer = '$CookieID_customer'
              and PO.PO_Number = 0
              and PO.po_status = 1

        ");
        if ($customer_type=="retail") {
            $po_item = DB::select("
                SELECT POI.id,POI.ID_customer, POI.ID_product, POI.product_color, POI.Quantity,
                PD.ID_reference, PD.ID_categories, PD.product_name_th, PD.description_brief, PD.product_unit,
                PD.picture_path, PD.shipping_weight,
                    case
                    WHEN retail_discount_dateStart <= now()
                    and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN retail_price - retail_discount
                    else retail_price
                    END as final_price
                FROM po_items POI, products PD
                where POI.ID_product = PD.id
                and POI.PO_Number = 0
                and POI.ID_customer = '$CookieID_customer'
                order by PD.product_name_th, POI.product_color

            ");
        }else if ( ($customer_type=="wholesale") || ($customer_type=="salesman")){
            $po_item = DB::select("
                SELECT POI.id,POI.ID_customer, POI.ID_product, POI.product_color, POI.Quantity,
                PD.ID_reference, PD.ID_categories, PD.product_name_th, PD.description_brief, PD.product_unit,
                PD.picture_path, PD.shipping_weight,
                    POI.final_price
                FROM po_items POI, products PD
                where POI.ID_product = PD.id
                and POI.PO_Number = 0
                and POI.ID_customer = '$CookieID_customer'
                order by PD.product_name_th, POI.product_color
            ");
        }


        return view( 'Cart.Create_PO', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration(),
            'po_master' => $po_master,
            'po_items' => $po_item,
            'ID_customer' => $CookieID_customer,
            'po_mastermain' => $this->get_po_master($CookieID_customer)

        ]);
    }


    public function Payment(Request $request)
    {
        // dd("PO_payment ");
        //echo 'index';

        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            //dd("CookieID_customer = 0 = 0yment ");
            $CookieID_customer = 0;
            return redirect()->route('index.index')->with('success', '');
        }
        // Update PO ไม่ต้อง แล้ว ทำที่หน้า PO_edit หมดแล้ว

        // 3. Show PO
        // dd($this->count_Quantity);

        $po_master = DB::select("

            SELECT PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                CUS.customer_type, CUS.payment_type, CUS.email

            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.ID_customer = '$CookieID_customer'
              and PO.PO_Number = 0
              and PO.po_status = 1

        ");

        // 2.7 หารายละเอียดของลูกค้า
        $customers = DB::select("
            SELECT  id , email , flname , customer_type , customer_tag , mobile , fax , payment_type , shipping_type ,
            company , company_tag , billing_flname , billing_address , billing_city , billing_province , billing_zipcode ,
            billing_telephone , shipping_flname , shipping_address , shipping_city , shipping_province , shipping_zipcode ,
            shipping_telephone
            FROM  customers
            WHERE id = $CookieID_customer
        ");

        return view('Cart.Payment', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration(),
            'po_master' => $po_master,
            'customers' => $customers,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }


    public function Payment_Success(Request $request)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type = Cookie::get( 'customer_type');
        } else {
            //dd("CookieID_customer = 0 = 0yment ");
            $CookieID_customer = 0;
            $customer_type = "retail";
            return redirect()->route('index.index')->with('success', '');
        }

        $date_array = getdate();
        $YYYY = $date_array['year'];
        $mm = $date_array['mon'];
        $maxid = po_master::max('id');
        if ($mm<10) {
          $mms = "0".$mm;
        }
        //$New_PO_Number = $YYYY . $SS . $CookieID_customer . "-" . $maxid;
        $New_PO_Number = $maxid."-".$YYYY . $mms . $CookieID_customer  ;

        if ($request->CreditTerm == "CreditTerm_Cash"){
            if ($request->file('file_picture_path')->isValid()) {

                ////////////////////////////////////////////////////////////
                // 2. Add picture
                ////////////////////////////////////////////////////////////
                $picture = new picture();
                $image = $request->file('file_picture_path');
                $namerand = rand(10000000, 99999999);
                $name = str_slug($New_PO_Number) . '-' . $namerand . '.' . $image->getClientOriginalExtension();
                $path = '//payment_images//' . $YYYY . '//' . $New_PO_Number;           // สร้างรูปแบบ path  แบบสร้างจริง
                $destinationPath = public_path($path);      // Get path of public

                $image->move($destinationPath, $name);

                // Add Picture
                //$picture->picture_path = $imagePath;                                // Path แบบเต็ม
                $shortPath = "\payment_images\\" . $YYYY . '\\' . $New_PO_Number . "\\" . $name;

                $picture->picture_path = $shortPath;                                  // Path สั้น
                $picture->First_ID_product = 999;                                     // ใช้ ID สินค้า ที่เข้าครั้งแรก
                $picture->picture_description = $New_PO_Number;
                $picture->save();
                $payment = "Cash";
                $payment_images = $shortPath;
            } else {
                echo "Not --> hasFile('picture_path') " . $request->file('picture_path');
            }

        }else{
            $payment = $request->CreditTerm;
            $payment_images = "-";
        }

        // Update การ Select เป็น ไม่ Select ทั้งหมด และต้อง เป็นที่ยังไม่ไช่ PO
        // Update รหัส PO ใหม่  PO นี้
        DB::table('po_masters')
            ->where('PO_Number', 0)
            ->where('ID_customer', $CookieID_customer)
            ->update([
                'PO_Number' => $New_PO_Number,
                'payment' => $payment,
                'payment_image' => $payment_images,
                'PO_date' => now(),
                'po_status' => '2'
            ]);

        // Update รหัส PO ใหม่ ใน Items ของ PO นี้
        DB::table('po_items')
            ->where('PO_Number', '0')
            ->where('ID_customer', $CookieID_customer)
            ->update([
                'PO_Number' => "$New_PO_Number"
            ]);

        // ลบรายการในตัวชั่วคราว
        DB::table('prs')
            ->where('Customer_Select', 'ON')
            ->where('ID_customer', $CookieID_customer)
            ->delete();


        // หาค่า  Email
        $po_masters = DB::select("
            SELECT  PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                CUS.customer_type, CUS.payment_type, CUS.email, CUS.flname
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
                and PO.PO_Number = '$New_PO_Number'
        ");
         foreach ($po_masters as $po_master) {

         }
        $email_admin_all    = $this->get_configuration_by_name('email_admin_all');
        $path_image_product = $this->get_configuration_by_name('path_image_product');
        $path_image_system  = $this->get_configuration_by_name('path_image_system');

        Mail::to($po_master->email)
        ->bcc($email_admin_all)
        ->send(new Order_Confirmed2($New_PO_Number,$path_image_product,$path_image_system));
        return view('Cart.Thankyou', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration(),
            'po_master' => $po_masters,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);

    }

    public function store(Request $request)
    {
        //
    }


    public function show($id)
    {
        //
    }


    public function edit($id)
    {
        //
    }

    public function Update_Cart(Request $request)
    {

        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
        }
        // ไม่สนใจว่า จะ Clik อันไหน ให้สนใจตัวสุดท้ายพอ
        // echo " =================================== <br>";
        // echo " Update_Cart ". $request->get('ID_customer')."<br>";
        // echo " =================================== <br>";
        // Update การ Select เป็น ไม่ Select ทั้งหมด และต้อง เป็นที่ยังไม่ไช่ PO
        DB::table('prs')
            ->where('ID_PO', 0)
            ->where('ID_customer', $request->get('ID_customer'))
            ->update(['Customer_Select' => 'OFF']);

        //  Update ค่า Select และ ยอดการสั่ง
        if ($request->get('arr_select_product') != "") {  // ต้องมี การ Item Cart ซัก 1 ตัว
            $i = -1;
            foreach ($request->get('arr_ID_PR') as $arr_ID_PR) {
                $i++;
                //echo "<br> ลำดับ : " . $i . "<br> arr_ID_product :: " . $arr_ID_PR;
                foreach ($request->get('arr_select_product') as $arr_select_product) {
                    if ($arr_select_product == $arr_ID_PR) {
                        $update_Cart = pr::find($arr_select_product);
                        $update_Cart->Customer_Select = "ON";
                        $update_Cart->Quantity = $request->get('arr_Quantity')[$i];
                        $update_Cart->save();
                    }
                }
            }
        } else { }

        $this->count_Quantity = 0;
        $count_monney = 0;
        $count_weight = 0;
        if ( $customer_type=="retail"){
            $PR_Item = DB::select("
                SELECT
                    PR.ID_PO, PR.ID_product ,PR.product_color, PR.ID_customer, PD.product_name_th, PD.shipping_weight,
                    PR.Quantity, PD.retail_price, PD.retail_discount, PD.product_unit,
                CASE
                    WHEN   retail_discount_dateStart <= now()
                    and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY)= now()
                    THEN   retail_price - retail_discount
                    ELSE   retail_price
                END AS   retail_update_final_price,

                (CASE
                    WHEN   retail_discount_dateStart <= now()
                    and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   retail_price - retail_discount
                    ELSE   retail_price
                END) * PR.Quantity as total

                FROM prs PR, products PD
                where PR.ID_product = PD.id
                and  PR.ID_customer = $CookieID_customer
                and  PR.ID_PO=0
                and  PR.Customer_Select='ON'
            ");

        }else if (( $customer_type=="wholesale") || ($customer_type=="salesman")){

            /*  ก่อนหน้า มีการปิดไว้   7/6/62  */
            $PR_Item = DB::select("
                SELECT
                    PR.ID_PO, PR.ID_product ,PR.product_color, PR.ID_customer, PD.product_name_th, PD.shipping_weight,
                    PR.Quantity, PD.wholesale_price, PD.wholesale_discount, PD.product_unit,
                CASE
                    WHEN   wholesale_discount_dateStart <= now()
                    and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   wholesale_price - wholesale_discount
                    ELSE   wholesale_price
                END AS   wholesale_update_final_price,

                (CASE
                    WHEN   wholesale_discount_dateStart <= now()
                    and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   wholesale_price - wholesale_discount
                    ELSE   wholesale_price
                END) * PR.Quantity as total

                FROM prs PR, products PD
                where PR.ID_product = PD.id
                and  PR.ID_customer = $CookieID_customer
                and  PR.ID_PO=0
                and  PR.Customer_Select='ON'
            ");
        }


        foreach ($PR_Item as $PR_Item) {
            $this->count_Quantity = $this->count_Quantity + $PR_Item->Quantity;     // จำนวนสินค้า
            $count_monney = $count_monney + $PR_Item->total;            // ยอดเงินหักส่วนลด
            $count_weight = $count_weight + ($PR_Item->shipping_weight * $PR_Item->Quantity);  // น้ำหนักสินค้า * จำนวนที่สั่ง
        }
        // dd($this->count_Quantity);

        $this->sum_weight = $count_weight / 1000;  // แปลงค่ากรัม เป็น กิโลกรัม
        $this->sum_total  = $count_monney;
        $this->read_delivery_configuration($CookieID_customer, 'pr_items');
        // Return ---->  $this->sum_weight;  / x
        // Return ---->  $this->sum_total;  /  x
        // Return ---->  $this->delivery_NormalPrice_final; /
        // Return ---->  $this->delivery_SpecialPrice_final;  x
        // Return ---->  $this->delivery_rate_normal_time;  /
        // Return ---->  $this->delivery_rate_special_time;   x

        $total = $this->sum_total + $this->delivery_NormalPrice_final;
        if ($this->count_Quantity < 1) {
            $this->delivery_NormalPrice_final = 0;
            $total = 0;
        }


        echo "<table class=\"table table-sm\"><tbody>";
            echo "<tr><td>ยอดรวม</td> <td align=\"right\">(<b> ". number_format($this->count_Quantity, 0, ". " , "," ) . "</b> ชิ้น)  ฿" . number_format ($count_monney, 2,   " .", " ,") . " </td> </tr>";
            echo "<tr><td>ค่าจัดส่ง</td> <td align=\"right\">฿" . number_format($this->delivery_NormalPrice_final, 2, ".", ",") . "</td> </tr>";
            echo "<tr><td>ยอดรวมทั้งสิ้น</td> <td align=\"right\"><b>฿" . number_format($total, 2, ".", ",") . "</b></td> </tr>";
        echo "</tbody></table>";
       // echo "<button type=\"submit\" class=\"btn btn-warning btn-lg btn-block\"> สั่งซื้อสินค้า </button>";

       return;
}


    public function Update_Cart_wholesale(Request $request)
    {

        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
        }
        // ไม่สนใจว่า จะ Clik อันไหน ให้สนใจตัวสุดท้ายพอ
        // echo " =================================== <br>";
        // echo " Update_Cart ". $request->get('ID_customer')."<br>";
        // echo " =================================== <br>";
        // Update การ Select เป็น ไม่ Select ทั้งหมด และต้อง เป็นที่ยังไม่ไช่ PO
        DB::table('prs')
            ->where('ID_PO', 0)
            ->where('ID_customer', $request->get('ID_customer'))
            ->update(['Customer_Select' => 'OFF']);

        //  Update ค่า Select และ ยอดการสั่ง
        if ($request->get('arr_select_product') != "") {  // ต้องมี การ Item Cart ซัก 1 ตัว
            $i = -1;
            foreach ($request->get('arr_ID_PR') as $arr_ID_PR) {
                $i++;
                //echo "<br> ลำดับ : " . $i . "<br> arr_ID_product :: " . $arr_ID_PR;
                foreach ($request->get('arr_select_product') as $arr_select_product) {
                    if ($arr_select_product == $arr_ID_PR) {
                        $update_Cart = pr::find($arr_select_product);
                        $update_Cart->Customer_Select = "ON";
                        $update_Cart->Quantity = $request->get('arr_Quantity')[$i];
                        $update_Cart->final_price = $request->get('arr_final_price')[$i];
                        $update_Cart->save();
                    }
                }
            }
        } else { }

        $this->count_Quantity = 0;
        $count_monney = 0;
        $count_weight = 0;
        if ( $customer_type=="retail"){
            // $PR_Item = DB::select("
            //     SELECT
            //         PR.ID_PO, PR.ID_product ,PR.product_color, PR.ID_customer, PD.product_name_th, PD.shipping_weight,
            //         PR.Quantity, PD.retail_price, PD.retail_discount, PD.product_unit,
            //     CASE
            //         WHEN   retail_discount_dateStart <= now()
            //         and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY)= now()
            //         THEN   retail_price - retail_discount
            //         ELSE   retail_price
            //     END AS   retail_update_final_price,
            //
            //     (CASE
            //         WHEN   retail_discount_dateStart <= now()
            //         and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
            //         THEN   retail_price - retail_discount
            //         ELSE   retail_price
            //     END) * PR.Quantity as total
            //
            //     FROM prs PR, products PD
            //     where PR.ID_product = PD.id
            //     and  PR.ID_customer = $CookieID_customer
            //     and  PR.ID_PO=0
            //     and  PR.Customer_Select='ON'
            // ");

        }else if (( $customer_type=="wholesale") || ($customer_type=="salesman")){
            $PR_Item = DB::select("
                SELECT
                    PR.ID_PO, PR.ID_product ,PR.product_color, PR.ID_customer, PD.product_name_th, PD.shipping_weight,
                    PR.Quantity,  PD.product_unit,

                    PR.final_price * PR.Quantity as total

                FROM prs PR, products PD
                where PR.ID_product = PD.id
                and  PR.ID_customer = $CookieID_customer
                and  PR.ID_PO=0
                and  PR.Customer_Select='ON'
            ");
        }


        foreach ($PR_Item as $PR_Item) {
            $this->count_Quantity = $this->count_Quantity + $PR_Item->Quantity;     // จำนวนสินค้า
            $count_monney = $count_monney + $PR_Item->total;            // ยอดเงินหักส่วนลด
            $count_weight = $count_weight + ($PR_Item->shipping_weight * $PR_Item->Quantity);  // น้ำหนักสินค้า * จำนวนที่สั่ง
        }
        // dd($this->count_Quantity);

        $this->sum_weight = $count_weight / 1000;  // แปลงค่ากรัม เป็น กิโลกรัม
        $this->sum_total  = $count_monney;
        $this->read_delivery_configuration($CookieID_customer, 'pr_items');
        // Return ---->  $this->sum_weight;  / x
        // Return ---->  $this->sum_total;  /  x
        // Return ---->  $this->delivery_NormalPrice_final; /
        // Return ---->  $this->delivery_SpecialPrice_final;  x
        // Return ---->  $this->delivery_rate_normal_time;  /
        // Return ---->  $this->delivery_rate_special_time;   x

        $total = $this->sum_total + $this->delivery_NormalPrice_final;
        if ($this->count_Quantity < 1) {
            $this->delivery_NormalPrice_final = 0;
            $total = 0;
        }


        echo "<table class=\"table table-sm\"><tbody>";
            echo "<tr><td>ยอดรวม</td> <td align=\"right\">(<b> ". number_format($this->count_Quantity, 0, ". " , "," ) . "</b> ชิ้น)  ฿" . number_format ($count_monney, 2,   " .", " ,") . " </td> </tr>";
            echo "<tr><td>ค่าจัดส่ง</td> <td align=\"right\">฿" . number_format($this->delivery_NormalPrice_final, 2, ".", ",") . "</td> </tr>";
            echo "<tr><td>ยอดรวมทั้งสิ้น</td> <td align=\"right\"><b>฿" . number_format($total, 2, ".", ",") . "</b></td> </tr>";
        echo "</tbody></table>";
       // echo "<button type=\"submit\" class=\"btn btn-warning btn-lg btn-block\"> สั่งซื้อสินค้า </button>";

       return;
}



public function destroy($id)
{ }

public function Delete_Cart(Request $request)
{
    DB::table('prs')
        ->where('id', '=', $request->get('id'))
        ->delete();
}

public function Delete_PO_item(Request $request)
{
        // หาว่า รหัสนีสินค้า ว่าเป็นอะไร
        // ไปลบออกจาก prs จาก PO = 0, CookieID_customer และ รหัสนี้ และ สีนี้
        $po_items = DB::select("
                SELECT id, PO_Number, ID_product, product_color, ID_customer
                FROM po_items
                where id =$request->get('id')
        ");

        foreach ( $po_items as $po_items) {

            DB::table('prs')
                ->where('ID_PO',0)
                ->where('ID_product', $po_items->ID_product)
                ->where('product_color', $po_items->product_color)
                ->where('ID_customer', $po_items->ID_customer)
                ->delete();

            DB::table('po_items')
                ->where('id', '=', $request->get('id'))
                ->delete();
        }

}

public function PO_view($id)
{
    if (Cookie::get('customer_id') != false) {
        $CookieID_customer = Cookie::get('customer_id');
    } else {
        $CookieID_customer = 0;
    }
    // 3. Show PO
    $PO_Number = $id;

    $po_master = DB::select("

            SELECT PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                CUS.customer_type, CUS.payment_type, CUS.email,
                PO.cancel_comment, PO.cancel_date,
                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by, PO.Shipping_ref, PO.Shipping_image,
                PO.Shipping_date, PO.Shipping_emp, PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,PO.updated_at

            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.PO_Number = '$PO_Number'

        ");
    // dd($po_master);
    $po_item = DB::select("
            SELECT POI.id,POI.ID_customer, POI.ID_product, POI.product_color, POI.Quantity,
            PD.ID_reference, PD.ID_categories, PD.product_name_th, PD.description_brief, POI.product_unit,
            PD.picture_path, PD.shipping_weight, POI.final_price
            FROM po_items POI, products PD
            where POI.ID_product = PD.id
            and POI.PO_Number = '$PO_Number'

    ");

  //  dd($po_master);
    if (count($po_master)==0){
      return redirect()->route('Mainmenu.index')->with('Error', '');
    }else {
      return view('Cart.PO_view', [
          'sess_grandparent_categories' => $this->grandparent_categories(),
          'sess_sub_categories' => $this->sub_categories(),
          'sess_categorie' => $this->sub_concat_categories(),
          'sess_categorie_short' => $this->categories(),
          'product_list20' => $this->categories(),
          'arr_configuration' => $this->get_configuration(),
          'po_master' => $po_master,
          'po_items' => $po_item,
          'po_mastermain' => $this->get_po_master($CookieID_customer)
      ]);
    }

}
}
