<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

use DB;
use Cookie;
use Session;
use App\employees as employee;
use App\customers as customer;
use App\products as product;
use App\pictures as picture;
use App\products_categories_parents as products_categories_parents;
use App\products_categories as categorie;
use App\products_likes as products_like;
use App\log_logins as log_login;
use App\prs as pr;

use getClientIps;
use App\configurations as configuration;



class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;

    public $customer_id;
    public $flname;
    public $email;
    public $customer_type;
    public $password;
    public $status;
    public $description;
    public $birthday;
    public $gender;
    public $mobile;
    public $newsletter;
    public $clientIP;

    public $delivery_rate_normal_price;
    public $delivery_rate_normal_time;
    public $delivery_rate_special_price;
    public $delivery_rate_special_time;
    public $sum_weight;
    public $sum_total;
    public $count_Quantity;
    public $delivery_NormalPrice;
    public $delivery_SpecialPrice;
    public $delivery_NormalPrice_final;
    public $delivery_SpecialPrice_final;

    public $Lifetime_Front_cookies;
    public $customer_order;

    public function get_client_ipmain()
    {
        $ipaddress = '';
        if (isset($_SERVER['HTTP_CLIENT_IP']))
            $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
        else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_X_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
        else if (isset($_SERVER['HTTP_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_FORWARDED'];
        else if (isset($_SERVER['REMOTE_ADDR']))
            $ipaddress = $_SERVER['REMOTE_ADDR'];
        else
            $ipaddress = 'UNKNOWN';
        return $ipaddress;
    }


    public function SaveLogmain()
    {

        $log_logins = new log_login([
            'ip' => $this->get_client_ipmain(),
            'email' => $this->email,
            'password' => $this->password,
            'status' => $this->status,
            'description' => $this->description
        ]);
        $log_logins->save();
    }

    public function SaveCookiemain()
    {
        $this->Lifetime_Front_cookies    = $this->get_configuration_by_name('Lifetime_Front_cookies')*1140;  // 1 วัน = 60 * 24

        Cookie::queue('Lifetime_Front_cookies', $this->Lifetime_Front_cookies, $this->Lifetime_Front_cookies);
        Cookie::queue('customer_id', $this->customer_id,        $this->Lifetime_Front_cookies);
        Cookie::queue('customer_type', $this->customer_type,    $this->Lifetime_Front_cookies);
        Cookie::queue('customer_name', $this->flname,           $this->Lifetime_Front_cookies);
        Cookie::queue('customer_email', $this->email,           $this->Lifetime_Front_cookies);
    //    Cookie::queue('customer_password', $this->password, $this->Lifetime_Front_cookies);
        Cookie::queue('customer_birthday', $this->birthday,     $this->Lifetime_Front_cookies);
        Cookie::queue('customer_gender', $this->gender,         $this->Lifetime_Front_cookies);
        Cookie::queue('customer_mobile', $this->mobile,         $this->Lifetime_Front_cookies);
        Cookie::queue('customer_newsletter', $this->newsletter, $this->Lifetime_Front_cookies);


        ////////////////////////////////////////////////
        //Store items in session
        ////////////////////////////////////////////////
        // session(['session_customer_id' => $this->customer_id, 'session_customer_name' => $this->flname]);
        // session(['session_customer_email' => $this->email, 'session_customer_type' => $this->customer_type]);
    }



    public function get_configuration()
    {
        $configuration = DB::select("
                    SELECT configuration_name, configuration_value
                    FROM configurations
                    where enable='ON'
        ");
        foreach ( $configuration as $configuration1) {

            if ( $configuration1->configuration_name == "path_image_product") {    // On web  Cookie::queue('path_pics', "https://admin.winnerprize.co.th/EcmAdmin/public", 525600);
                $arr_configuration[1] = $configuration1->configuration_value;      // path_image_product   path_pics    path_image_product http://localhost/admin/public
            }
            if ( $configuration1->configuration_name =="path_image_system") {      // Cookie::queue('path_pics2', "https://admin.winnerprize.co.th/EcmAdmin/public/images/", 525600);
                $arr_configuration[2] = $configuration1->configuration_value;      // path_image_system   path_pics2   path_image_system  http://localhost/admin/public/images/
            }
            if ( $configuration1->configuration_name == "path_image_payment") {
                $arr_configuration[5] = $configuration1->configuration_value;      // path_image_payment
            }
            // if ($configuration1->configuration_name == "single_new_arrivals") {
            //     $arr_configuration[6] = $configuration1->configuration_value;          // single_new_arrivals
            // }
            // if ($configuration1->configuration_name == "single_product_flashsale") {
            //     $arr_configuration[7] = $configuration1->configuration_value;          // single_product_flashsale
            // }
            if ($configuration1->configuration_name == "delivery_rate_normal_price") {
                $arr_configuration[8] = $configuration1->configuration_value;          //  delivery_rate_normal_price จัดส่งฟรีเมื่อสั่งสินค้า
            }
            if ($configuration1->configuration_name == "delivery_rate_special_price"){
                $arr_configuration[9] = $configuration1->configuration_value;          //  delivery_rate_special_price
            }
            if ($configuration1->configuration_name == "delivery_rate_normal_time"){
                $arr_configuration[10] = $configuration1->configuration_value;          //   delivery_rate_normal_time
            }
            if ($configuration1->configuration_name == "delivery_rate_special_time"){
                $arr_configuration[11] = $configuration1->configuration_value;          //  delivery_rate_special_time
            }
            if ($configuration1->configuration_name == "Lifetime_Front_cookies"){
                $arr_configuration[14]  = $configuration1->configuration_value;          //  delivery_rate_special_time
                $this->Lifetime_Front_cookies = $configuration1->configuration_value;
            }
            if ($configuration1->configuration_name == "customer_order"){
                $arr_configuration[16]  = $configuration1->configuration_value;          //  delivery_rate_special_time
                $this->customer_order   = $configuration1->configuration_value;
            }
        }

        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $sum_cart = $this->summary_cart($CookieID_customer);
            $arr_configuration[3] = $sum_cart[1];
            $arr_configuration[4] = $sum_cart[2];
            $arr_configuration[12] = $this->count_wishlist($CookieID_customer);
        } else {
            $arr_configuration[3] = 0;
            $arr_configuration[4] = 0;
            $arr_configuration[12] = 0;
        }
        return $arr_configuration;
    }

    public function get_configuration_by_name($configuration_name)
    {
        $configuration = configuration::where('configuration_name', '=', $configuration_name)->get();
        foreach ( $configuration as $configuration)
            return $configuration->configuration_value;

    }

    public function count_wishlist($ID_customer)
    {
      $data = products_like::where('ID_customer', '=', $ID_customer)->count();
      return $data;
    }

    public function find_grandparent_categories($id_categories)
    {
        $data = DB::select("
                SELECT
                    PP.id as id_parent,
                    PC.sub_categories as id_sub,
                    PC.id as id_cat,
                    PC.position,
                    PP.categories_parent,
                    PS.categories_sub,
                    PC.categories
                    FROM products_categories PC,
                    products_categories_subs PS,
                    products_categories_parents PP
                    WHERE
                          PC.enable =\"on\"
                    and   PC.sub_categories = PS.id
                    and   PS.id_parent = PP.id
                    and   PC.id = $id_categories
        ");
        foreach ($data as $products_categorie1) {
            $PP_PS_PC[1] = $products_categorie1->categories_parent;
            $PP_PS_PC[2] = $products_categorie1->categories_sub;
            $PP_PS_PC[3] = $products_categorie1->categories;
            $PP_PS_PC[4] = $products_categorie1-> id_parent;
            $PP_PS_PC[5] = $products_categorie1-> id_sub;
            $PP_PS_PC[6] = $products_categorie1-> id_cat;


        }
        return $PP_PS_PC;
    }


    // หมวดหลัก
    public function grandparent_categories()
    {
        $data = DB::select("
            SELECT id, categories_parent
            FROM products_categories_parents
             where enable = 'ON'
        ");
        return $data;
    }

    // หมวดย่อย
    public function sub_categories()
    {
        $data = DB::select( "
        SELECT id as id_sub_categories, categories_sub
            FROM products_categories_subs
            where enable = 'ON'
            ORDER BY `id_parent`
        ");
        return $data;
    }

    // รูปหมวดย่อย
    public function sub_categories_picture()
    {
        $data = DB::select( "
            SELECT pcs.id as id_sub_categories, pcs.id_parent,  pcs.categories_sub,p.picture_path
            FROM products_categories_subs pcs,  pictures p
            where pcs.enable = 'ON'
            and   pcs.categories_sub = p.picture_description
        ");
        return $data;
    }

    // หมู่สินค้า
    // Jc แก้การ Sort from Id -> categories
    public function categories()
    {
        $data = DB::select( "
        SELECT id, position, categories
            FROM products_categories
            where enable = 'ON'
            ORDER BY categories
        ");
        return $data;
    }

    // หมวดย่อย @ หมู่สินค้า
    public function sub_concat_categories()
    {
        $data = DB::select( "
                SELECT PC.id, CONCAT(PS.categories_sub, '@', PC.categories) as CONCAT
                FROM products_categories_subs PS, products_categories PC
                where PC.sub_categories=PS.id
                and PC.enable='ON'
        ");
        return $data;
    }


    public function categories_all()
    {
        $data = DB::select("
                SELECT
                    PP.id as id_parent,
                    PC.sub_categories as id_sub,
                    PC.id as id_cat,
                    PC.position,
                    PP.categories_parent,
                    PS.categories_sub,
                    PC.categories
                    FROM products_categories PC,
                    products_categories_subs PS,
                    products_categories_parents PP
                    WHERE
                          PC .enable =\"on\"
                    and   PC.sub_categories = PS.id
                    and   PS.id_parent = PP.id
        ");
        return $data;
    }


    public function product_list20()
    {
        $data = product::where('product_name_th', 'like', '%%')
            ->where('enable', '=', 'ON')
            ->orderBy('product_name_th', 'ASC')
            ->take(20)
            ->get();

        return $data;
    }


    public function summary_cart($ID_customer)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
           // echo "--jjjjj---". $CookieID_customer;

        }else{
            $CookieID_customer = 0;
            $customer_type="retail";
            //Cookie::queue('customer_type', $customer_type, $this->Lifetime_Front_cookies);
           // echo "-----";
        }

        if ($customer_type=="") {
            $customer_type="retail";
        }


        if ($customer_type=="retail") {

            $data = DB::select("
                SELECT sum(PR.Quantity) as sum_Quantity, sum(PR.Quantity * PP.retail_final_price) as total
                FROM prs PR, products PP
                where
                PR.ID_product = PP.id
                and PR.ID_customer = $CookieID_customer
                and PR.ID_PO = 0
                and PR.Customer_Select = 'ON'
            ");

        } else if (( $customer_type=="wholesale") || ($customer_type=="salesman")){

            $data = DB::select("
                SELECT sum(PR.Quantity) as sum_Quantity, sum(PR.Quantity * PR.final_price) as total
                FROM prs PR, products PP
                where
                PR.ID_product = PP.id
                and PR.ID_customer = $CookieID_customer
                and PR.ID_PO = 0
                and PR.Customer_Select = 'ON'
            ");
        }else{
          //dd( $customer_type);
        }

        foreach ($data as $data) {
            $sum_cart[1] = $data->sum_Quantity;
            $sum_cart[2] = $data->total;
        }
        return $sum_cart;
    }


    public function read_delivery_configuration($ID_customer, $type_bill)
    {   // 2.3 อ่านค่า Configuration
        $data = DB::select("
                    SELECT configuration_name, configuration_value
                    FROM configurations
                    where enable='ON'
        ");
        foreach ($data as $data) {
            if ($data->configuration_name == 'delivery_rate_normal_price') {
                $this->delivery_rate_normal_price = $data->configuration_value;     // เช่น 2000
                //echo "<br>delivery_rate_normal_price ".$this->delivery_rate_normal_price;
            }
            if ($data->configuration_name == 'delivery_rate_special_price') {
                $this->delivery_rate_special_price = $data->configuration_value;    // เช่น 4000
                //echo "<br>delivery_rate_special_price ".$this->delivery_rate_special_price;
            }
            if ($data->configuration_name == 'delivery_rate_normal_time') {               // เช่น 10
                $this->delivery_rate_normal_time = $data->configuration_value;
                //echo "<br>delivery_rate_normal_time ".$this->delivery_rate_normal_time;
            }
            if ($data->configuration_name == 'delivery_rate_special_time') {              // เช่น 5
                $this->delivery_rate_special_time = $data->configuration_value;
                //echo "<br>delivery_rate_special_time ".$this->delivery_rate_special_time;
            }
        }

        //////////////////////////////////////////////
        // 2.2 หาผลรวบบิล และน้ำหนัก sumweight  total

        if ($type_bill== 'po_items'){

            $this->sum_weight = 0;
            $this->sum_total = 0;
            $bill_total = DB::select("
                SELECT sum(Quantity) as Quantity, sum(shipping_weight*Quantity/1000) as weight, sum(total) as total
                FROM po_items
                where ID_customer = $ID_customer
                    and PO_Number = 0
            ");
            foreach ($bill_total as $bill_total) {
                $this->count_Quantity = $bill_total->Quantity;
                $this->sum_weight     = $bill_total->weight;
                $this->sum_total      = $bill_total->total;
            }
            //echo "2.2 หาผลรวบบิล sum_weight".$this->sum_weight;
           // dd();
        }else{
            // Pr ทำมาแล้ว
            //echo "<br> Pr ทำมาแล้ว  sum_weight".$this->sum_weight;
            //echo "<br> Pr ทำมาแล้ว  sum_total".$this->sum_total;
        }

        // 2.4 หาน้ำหนักค่าขนส่งตามน้ำหนัก
        $this->delivery_NormalPrice = 0;
        $this->delivery_SpecialPrice = 0;
        $this->delivery_NormalPrice_final = 0;
        $this->delivery_SpecialPrice_final = 0;

        //echo "<br>Controller : sum_weight".$this->sum_weight;

        $delivery_rate = DB::select("
            SELECT NormalPrice, SpecialPrice FROM delivery_rates
                where kgFrom <= '$this->sum_weight'
                 and kgEnd > '$this->sum_weight'
        ");
        foreach ($delivery_rate as $data) {
            $this->delivery_NormalPrice = $data->NormalPrice;
            $this->delivery_SpecialPrice = $data->SpecialPrice;
        }
        //echo "<br>delivery_NormalPrice".$this->delivery_NormalPrice;
        //echo "<br>delivery_SpecialPrice".$this->delivery_SpecialPrice;

        // 2.5 หาน้ำหนักค่าขนส่งแบบธรรมดา
        if ($this->sum_total < $this->delivery_rate_normal_price) {
            // ให้คิดค่าขนส่ง
            $this->delivery_NormalPrice_final = $this->delivery_NormalPrice;
            //echo "<br>ให้คิดค่าขนส่ง";
        } else {
            // ไม่ต้องคิดค่าขนส่ง
            $this->delivery_NormalPrice_final = 0;
            //echo "<br>ไม่ต้องคิดค่าขนส่ง";

            //echo "<br>sum_total ". $this->sum_total;
            //echo "<br>delivery_rate_normal_price ".$this->delivery_rate_normal_price;
        }

        // 2.6 หาน้ำหนักค่าขนส่งแบบพิเศษ
        if ($this->sum_total < $this->delivery_rate_special_price) {
            // ให้คิดค่าขนส่ง
            $this->delivery_SpecialPrice_final = $this->delivery_SpecialPrice;
        } else {
            // ไม่ต้องคิดค่าขนส่ง
            $this->delivery_SpecialPrice_final = 0;
        }

        //echo " <br> delivery_NormalPrice_final ".$this->delivery_NormalPrice_final;
       //echo " <br> delivery_SpecialPrice_final ".$this->delivery_SpecialPrice_final;


        // return 6 values;
        // Return ---->  $this->sum_weight;  / x
        // Return ---->  $this->sum_total;  /  x
        // Return ---->  $this->delivery_NormalPrice_final; /
        // Return ---->  $this->delivery_SpecialPrice_final;  x
        // Return ---->  $this->delivery_rate_normal_time;  /
        // Return ---->  $this->delivery_rate_special_time;   x
        // Return ---->  $this->count_Quantity
    }

    public function DateThai($strDate)
    {
        $strYear = date("Y", strtotime($strDate)) + 543;
        $strMonth = date("n", strtotime($strDate));
        $strDay = date("j", strtotime($strDate));
        $strHour = date("H", strtotime($strDate));
        $strMinute = date("i", strtotime($strDate));
        $strSeconds = date("s", strtotime($strDate));
        $strMonthCut = array("", "ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค.");
        $strMonthThai = $strMonthCut[$strMonth];
        return "$strDay $strMonthThai $strYear";  //, $strHour:$strMinute
    }

    public function get_po_master($customer_id)
    {

        if ($customer_id != 0) {
            $po_mastermain = DB::select("
                    SELECT id, PO_Number, PO_date, Quantity
                    FROM po_masters
                    where ID_customer = $customer_id
                    and po_status in('2', '3', '4', '5', '6', '7')
                    order by PO_date DESC
            ");
        } else {
            $po_mastermain = "";
        }
        return $po_mastermain;
    }

    public function get_pr_list($customer_type, $ID_customer)
    {
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {

            $pr_list = DB::select("
                SELECT
                    PR.id, PR.ID_customer, PR.ID_product, PR.product_color, PR.Quantity, PR.Customer_Select,
                    PD.ID_reference, PD.ID_categories, PD.product_name_th, PD.description_brief, PD.product_unit,
                    PD.picture_path, PD.shipping_weight,
                    ##wholesale_price as price,               /* ก่อนหน้าปิด ค่าไว้ 7/6/62 */
                    ##wholesale_discount as discount,         /* ก่อนหน้าปิด ค่าไว้ 7/6/62 */
                    ##PR.final_price          ,               /* ก่อนหน้า 7/6/62   PR.final_price  */

                    ############################################################
                    #### ราคาส่ง ####
                    ############################################################
                    PD.wholesale_price as price,
                    PD.wholesale_discount as discount,
                    CASE
                        WHEN   PD.wholesale_price > 0
                        and  PD.wholesale_discount_dateStart <= now()
                        and  DATE_ADD(PD.wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   PD.wholesale_discount * 100 / PD.wholesale_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   PD.wholesale_discount_dateStart <= now()
                        and  DATE_ADD(PD.wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   PD.wholesale_price - PD.wholesale_discount
                        ELSE   PD.wholesale_price
                    END AS   final_price    ##wholesale_update_final_price


                    FROM prs PR, products PD
                    where PR.ID_product = PD.id
                    and PR.ID_customer =  $ID_customer
                    order by PD.product_name_th, PR.product_color
            ");
        }else{
            $pr_list = DB::select("
                SELECT
                    PR.id, PR.ID_customer, PR.ID_product, PR.product_color, PR.Quantity, PR.Customer_Select,
                    PD.ID_reference, PD.ID_categories, PD.product_name_th, PD.description_brief, PD.product_unit,

                    PD.picture_path, PD.shipping_weight,
                    retail_price as price,
                    retail_discount as discount,
                    CASE
                        WHEN   retail_price > 0
                        and  retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_discount * 100 / retail_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_price - retail_discount
                        ELSE   retail_price
                    END AS   final_price

                    FROM prs PR, products PD
                    where PR.ID_product = PD.id
                    and PR.ID_customer =  $ID_customer
                    order by PD.product_name_th, PR.product_color

            ");
        }

        return $pr_list;
    }

    public function get_product_view($ID_Product)
    {
        $product_view = DB::select("
            SELECT
                PC.id as id_categorie, PC.categories, PC.categories_parent,
                PD.id, PD.ID_reference, PD.ID_categories, PD.product_name_th, PD.description_brief, PD.description,
                PD.product_unit, PD.product_size, PD.shipping_weight, PD.picture_path, PD.new_arrivals, PD.product_color,
                PD.picture_color, PD.picture_trademark,

                ############################################################
                #### ราคาส่ง ####
                ############################################################
                PD.wholesale_price,
                PD.wholesale_discount,
                CASE
                    WHEN   PD.wholesale_price > 0
                    and  PD.wholesale_discount_dateStart <= now()
                    and  DATE_ADD(PD.wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   PD.wholesale_discount * 100 / PD.wholesale_price
                    ELSE   0
                END AS  wholesale_discount_percent,
                CASE
                    WHEN   PD.wholesale_discount_dateStart <= now()
                    and  DATE_ADD(PD.wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   PD.wholesale_price - PD.wholesale_discount
                    ELSE   PD.wholesale_price
                END AS   wholesale_update_final_price,

                ############################################################
                ####  ราคาปลีก ####
                ############################################################
                PD.retail_price,
                PD.retail_discount,
                CASE
                    WHEN   PD.retail_price > 0
                    and  PD.retail_discount_dateStart <= now()
                    and  DATE_ADD(PD.retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   PD.retail_discount * 100 / PD.retail_price
                    ELSE   0
                END AS  retail_discount_percent,
                CASE
                    WHEN   PD.retail_discount_dateStart <= now()
                    and  DATE_ADD(PD.retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN   PD.retail_price - PD.retail_discount
                    ELSE   PD.retail_price
                END AS   retail_update_final_price

                FROM products PD, products_categories PC
                        where PD.ID_categories=PC.id
                and PD.id= '$ID_Product'
        ");
        return $product_view;
    }

    public function get_single_new_arrivals($customer_type)
    {
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {
            $product_view2 = DB::select("
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th,
                    wholesale_price as price,
                    wholesale_discount as discount,
                    CASE
                        WHEN   wholesale_price > 0
                        and  wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_discount * 100 / wholesale_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_price - wholesale_discount
                        ELSE   wholesale_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where

                    PD.ID_categories=PC.id
                and PC.categories_parent=PCP.id
                group by PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,PD.product_name_th,
                    new_arrivals, wholesale_price, wholesale_discount,wholesale_discount_dateStart,wholesale_discount_dateEnd,
                    PD.id,picture_path, PD.updated_at, PD.ID_reference, PD.product_name_th
                order by rand()
                LIMIT 1

            ");
        }else{  ////////   Retail    ////////
            $product_view2 = DB::select("
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th,
                    retail_price as price,
                    retail_discount as discount,
                    CASE
                        WHEN   retail_price > 0
                        and  retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_discount * 100 / retail_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_price - retail_discount
                        ELSE   retail_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where
                    PD.ID_categories=PC.id
                and PC.categories_parent=PCP.id
                group by PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,PD.product_name_th,
                    new_arrivals, retail_price, retail_discount,retail_discount_dateStart,retail_discount_dateEnd,
                    PD.id,picture_path, PD.updated_at, PD.ID_reference, PD.product_name_th
                order by rand()
                LIMIT 1
            ");
        }
        return $product_view2;
    }


    public function get_product_Recent($customer_type, $ID_customer)
    {
        // สินค้าดูล่าสุด 1 แถว หน้าละ 6 รายการ
        $Product_Recent_List = $this->get_configuration_by_name('Product_Recent_List');
        if ($Product_Recent_List==""){
          $Product_Recent_List = 50;
        }
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {

            $product_Recent = DB::select("
                    SELECT id, ID_reference, ID_categories, product_name_th, picture_path,
                    new_arrivals,
                    wholesale_price as price,
                    wholesale_discount as discount,
                    CASE
                        WHEN   wholesale_price > 0
                        and  wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_discount * 100 / wholesale_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_price - wholesale_discount
                        ELSE   wholesale_price
                    END AS final_price
                    FROM products PD, products_recents PRC
                    where PD.id = PRC.ID_Product
                    and PD.enable = 'ON'
                    and PRC.ID_customer=' $ID_customer'
                    ORDER BY PRC.updated_at DESC
                    LIMIT $Product_Recent_List
            ");
        }else{
            ////////   Retail    ////////
            $product_Recent = DB::select("
                    SELECT id, ID_reference, ID_categories, product_name_th, picture_path, new_arrivals,
                    retail_price as price,
                    retail_discount as discount,
                    CASE
                        WHEN   retail_price > 0
                        and  retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_discount * 100 / retail_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_price - retail_discount
                        ELSE   retail_price
                    END AS   final_price
                    FROM products PD, products_recents PRC
                    where PD.id = PRC.ID_Product
                    and PD.enable = 'ON'
                    and PRC.ID_customer=' $ID_customer'
                    ORDER BY PRC.updated_at DESC
                    LIMIT $Product_Recent_List

            ");
        }
        return $product_Recent;
    }

    public function get_Best_sellers($customer_type, $categories_parent, $backdate, $showlimit)
    {
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {
            $Best_sellers = DB::select("
                SELECT PD.id, pi.ID_product, pi.product_name_th, picture_path, ID_reference,
                sum(pi.Quantity) as sumQuantity,
                PD.ID_categories,
                PC.categories,
                PC.categories_parent, PCP.categories_parent,

                    new_arrivals,
                    wholesale_price as price,
                    wholesale_discount as discount,
                    CASE
                        WHEN   wholesale_price > 0
                        and  wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_discount * 100 / wholesale_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_price - wholesale_discount
                        ELSE   wholesale_price
                    END AS final_price

                FROM po_items pi, products PD, products_categories PC, products_categories_parents PCP
                where
                    pi.ID_product = PD.id
                and  PD.ID_categories=PC.id
                and  PC.categories_parent=PCP.id
                and  pi.PO_Number<>'0'
                and  pi.created_at> DATE_ADD(now(), INTERVAL -$backdate DAY)
                and  PC.categories_parent = '$categories_parent'
                group by pi.ID_product,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,pi.product_name_th,
                        new_arrivals, wholesale_price, wholesale_discount,wholesale_discount_dateStart,wholesale_discount_dateEnd,PD.id, picture_path,ID_reference
                #### order by sumQuantity DESC
                order by rand()
                LIMIT $showlimit
            ");
        }else{
            ////////   Retail    ////////
            $Best_sellers = DB::select("
                SELECT PD.id, pi.ID_product, pi.product_name_th, picture_path, ID_reference,
                sum(pi.Quantity) as sumQuantity,
                PD.ID_categories,
                PC.categories,
                PC.categories_parent, PCP.categories_parent,
                    new_arrivals,
                    retail_price as price,
                    retail_discount as discount,
                    CASE
                        WHEN   retail_price > 0
                        and  retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_discount * 100 / retail_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_price - retail_discount
                        ELSE   retail_price
                    END AS final_price

                FROM po_items pi, products PD, products_categories PC, products_categories_parents PCP
                where
                    pi.ID_product = PD.id
                and  PD.ID_categories=PC.id
                and  PC.categories_parent=PCP.id
                and  pi.PO_Number<>'0'
                and  pi.created_at> DATE_ADD(now(), INTERVAL -$backdate DAY)
                and  PC.categories_parent = '$categories_parent'
                group by pi.ID_product,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,pi.product_name_th,
                        new_arrivals, retail_price, retail_discount,retail_discount_dateStart,retail_discount_dateEnd,PD.id, picture_path,ID_reference
                ####order by sumQuantity DESC
                order by rand()
                LIMIT $showlimit
            ");
        }
        return $Best_sellers;
    }

    public function get_new_arrivals($customer_type, $showlimit)
    {
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {
            $new_arrivals = DB::select( "
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th,
                    wholesale_price as price,
                    wholesale_discount as discount,
                    CASE
                        WHEN   wholesale_price > 0
                        and  wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_discount * 100 / wholesale_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_price - wholesale_discount
                        ELSE   wholesale_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where
                     PD.new_arrivals = 'ON'
                and  PD.ID_categories=PC.id
                and  PC.categories_parent=PCP.id
                group by PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,PD.product_name_th,
                        new_arrivals, wholesale_price, wholesale_discount,wholesale_discount_dateStart,wholesale_discount_dateEnd,
                        PD.id,picture_path, PD.updated_at, PD.ID_reference, PD.product_name_th
                order by rand()
                LIMIT $showlimit
            ");
        }else{
            ////////   Retail    ////////
            $new_arrivals = DB::select("
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th,
                    retail_price as price,
                    retail_discount as discount,
                    CASE
                        WHEN   retail_price > 0
                        and  retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_discount * 100 / retail_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_price - retail_discount
                        ELSE   retail_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where
                     PD.new_arrivals = 'ON'
                and  PD.ID_categories=PC.id
                and  PC.categories_parent=PCP.id
                group by PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,PD.product_name_th,
                        new_arrivals, retail_price, retail_discount,retail_discount_dateStart,retail_discount_dateEnd,
                        PD.id,picture_path, PD.updated_at, PD.ID_reference, PD.product_name_th
                ####order by PD.updated_at DESC
                order by rand()
                LIMIT $showlimit
            ");

        }
        return $new_arrivals;
    }

    public function get_flash_sale($customer_type, $categories_parent, $showlimit)
    {
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {
            $flash_sale = DB::select("
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th,
                    wholesale_price as price,
                    wholesale_discount as discount,
                    CASE
                        WHEN   wholesale_price > 0
                        and  wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_discount * 100 / wholesale_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_price - wholesale_discount
                        ELSE   wholesale_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where
                    (
                        (PD.wholesale_discount_dateStart <= now()
                    and DATE_ADD(PD.wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now())
                    or product_flashsale='ON'
                    )
                    and  PC.categories_parent = '$categories_parent'
                    and  PD.ID_categories=PC.id
                    and  PC.categories_parent=PCP.id
                order by rand()
                LIMIT $showlimit
            ");
        }else{
            ////////   Retail    ////////
            $flash_sale = DB::select("
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th,
                    retail_price as price,
                    retail_discount as discount,
                    CASE
                        WHEN   retail_price > 0
                        and  retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_discount * 100 / retail_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_price - retail_discount
                        ELSE   retail_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where
                    (
                        (PD.retail_discount_dateStart <= now()
                    and DATE_ADD(PD.retail_discount_dateEnd, INTERVAL 1 DAY) >= now())
                    or product_flashsale='ON'
                    )
                    and  PC.categories_parent = '$categories_parent'
                    and  PD.ID_categories=PC.id
                    and  PC.categories_parent=PCP.id
                order by rand()
                LIMIT $showlimit
            ");
        }
        return $flash_sale;
    }

    public function get_flash_sale_countdown($customer_type, $showlimit)
    {
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {
            $flash_sale = DB::select("
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th, PD.wholesale_discount_dateEnd as discount_dateEnd,
                    wholesale_price as price,
                    wholesale_discount as discount,
                    CASE
                        WHEN   wholesale_price > 0
                        and  wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_discount * 100 / wholesale_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   wholesale_discount_dateStart <= now()
                        and  DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   wholesale_price - wholesale_discount
                        ELSE   wholesale_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where
                        PD.wholesale_discount_dateStart <= now()
                    and DATE_ADD(PD.wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    and product_flashsale='ON'
                    and  PD.ID_categories=PC.id
                    and  PC.categories_parent=PCP.id
                    order by rand()
                ##    LIMIT $showlimit
            ");
        }else{
            ////////   Retail    ////////
            $flash_sale = DB::select("
                SELECT
                    PD.id, PD.picture_path ,PD.ID_categories, PC.categories, PC.categories_parent, PCP.categories_parent,
                    new_arrivals, PD.ID_reference, PD.product_name_th, PD.retail_discount_dateEnd as discount_dateEnd,
                    retail_price as price,
                    retail_discount as discount,
                    CASE
                        WHEN   retail_price > 0
                        and  retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_discount * 100 / retail_price
                        ELSE   0
                    END AS  discount_percent,
                    CASE
                        WHEN   retail_discount_dateStart <= now()
                        and  DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                        THEN   retail_price - retail_discount
                        ELSE   retail_price
                    END AS final_price
                FROM products PD, products_categories PC, products_categories_parents PCP
                where
                        PD.retail_discount_dateStart <= now()
                    and DATE_ADD(PD.retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    and product_flashsale='ON'
                    and  PD.ID_categories=PC.id
                    and  PC.categories_parent=PCP.id
                    order by rand()
                  ##  LIMIT $showlimit
            ");
        }
        return $flash_sale;
    }

    // ยอดสั่งซื้อ สะสม
    public function get_summary_po( $ID_customer)
    {
        $summary_po = DB::select( "
            SELECT
                sum(po_ grandtotal) as sum_po_grandtotal,
                sum(Quantity) as sum_Quantity
                FROM po_masters
                where ID_customer =ID_customer
                and po_status<>8
        ");
        return $summary_po;
    }

    // PR รอ PO
    public function get_summary_pr($customer_type, $ID_customer)
    {
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {

            $summary_pr = DB::select( "
                sum(
                    (CASE
                    WHEN   wholesale_discount_dateStart <= now()
                      and  wholesale_discount_dateEnd+1 >= now()
                    THEN   wholesale_price - wholesale_discount
                    ELSE   wholesale_price
                END) * PR.Quantity) as sumtotal,
                sum(PR.Quantity) as sum_Quantity

                FROM prs PR, products PD
                where PR.ID_product = PD.id
                and  PR.ID_customer =  $ID_customer
            ");
        }else{
            ////////   Retail    ////////
            $summary_pr = DB::select("
                sum(
                    (CASE
                    WHEN   retail_discount_dateStart <= now()
                      and  retail_discount_dateEnd+1 >= now()
                    THEN   retail_price - retail_discount
                    ELSE   retail_price
                END) * PR.Quantity) as sumtotal,
                sum(PR.Quantity) as sum_Quantity

                FROM prs PR, products PD
                where PR.ID_product = PD.id
                and  PR.ID_customer =  $ID_customer
            ");
        }
        return $summary_pr;
    }

    public function product_checklike($ID_product, $ID_customer)
    {
        $data = products_like::where('ID_product', '=', $ID_product)
            ->where('ID_customer', '=', $ID_customer)
            ->count();
        return $data;
    }

    public function get_path_picture($ID_picture)
    {
        $path_picture_color = picture::where('id',$ID_picture)->get();
        foreach ($path_picture_color as $path_picture_color)
            return $path_picture_color->picture_path;
    }
}
