<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use DB;
use Input;
use Cookie;
use App\employees as employee;
use App\customers as customer;
use App\customers_service as customers_service;
use PDF;

use Illuminate\Support\Facades\Mail;
use App\Mail\SendMailable_OrderCancel2;

class CustomerController extends Controller
{



    public function index()
    {
        //dd( 'edit_address');
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
            return redirect()->route('index.index')->with('success', 'กรุณา Login');
        }
        $this->get_configuration();
        $customer = customer::where('id', '=', $CookieID_customer)->get();
        return view('Customer.info')->with([
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'customer' => $customer,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);

    }


    public function customer_order(Request $request) {


        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
            $customer_order    = $this->get_configuration_by_name('customer_order');
        } else {
            $CookieID_customer = 0;
            $customer_type     = "retail";
            return redirect()->route('index.index')->with('success', 'กรุณา Login');
        }

        // 1. Show Customer Profile
        $this->get_configuration();
        $customer = customer::where('id', '=', $CookieID_customer)->get();

        if ( $request->get('nday')==""){
            $nday = 30;
        }else{
            $nday = $request->get('nday');
        }

        if ( $customer_order==""){
            $customer_order = 10;
        }

        //echo $nday;   ->where( 'PO_date', '>=', '$xx' )
        // 2. Show PO ถ้ามี
        $po_masters = DB::table('po_masters')
            ->where('ID_customer', '=', "$CookieID_customer")
            // ->join('customers', 'po_masters.ID_customer', '=', 'customers.id')
            ->where('po_status', '<>', "1")
            ->whereRaw("po_masters.updated_at >= DATE_ADD(NOW(), INTERVAL -$nday DAY)")
            ->orderBy('PO_date', 'DESC')
            ->paginate($customer_order);

        return view('Customer.customer_order', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration(),
            'po_masters' => $po_masters,
            'customer' => $customer,
            'nday' => $nday,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }


    public function save_cs(Request $request)
    {
      if (Cookie::get('customer_id') != false) {
          $CookieID_customer = Cookie::get('customer_id');
          $customer_type     = Cookie::get('customer_type');
      } else {
          $CookieID_customer = 0;
          $customer_type     ="retail";
      }

      $this->validate($request, [
          'ID_Customer' => 'required',
          'email' => 'required',
          'cs_type' => 'required',
          'message' => 'required'
      ]);
      $customers_service = new customers_service (
          [
            'ID_customer' => $request->get('ID_Customer'),
            'email' => $request->get('email'),
            'PO_Number' => $request->get('PO_Number'),
            'cs_type' => $request->get('cs_type'),
            'message' => $request->get('message')
          ]
      );
      $customers_service->save();
      //return redirect()->route('save_cs_message')->with('success', '');

      return view('Mainmenu.save_cs_message', [
          'sess_grandparent_categories'=> $this->grandparent_categories(),
          'sess_sub_categories' => $this->sub_categories(),
          'sess_categorie' => $this->sub_concat_categories(),
          'sess_categorie_short' => $this->categories(),
          'product_list20' => $this->categories(),
          'arr_configuration' => $this->get_configuration(),
          'product_Recent' => $this->get_product_Recent($customer_type,$CookieID_customer),
          'po_mastermain' => $this->get_po_master($CookieID_customer)
      ]);

    }





    public function cancel_po(Request $request)
    {
        $this->validate($request, [
            'cancel_comment' => 'required'
        ]);


        DB::table('po_masters')
            ->where('id', $request->get('id'))
            ->update([
                'cancel_comment' => $request->get('cancel_comment'),
                'po_status' => 8,   // 8. ยกเลิกใบคำสั่งซื้อ
                'cancel_date' => now()
        ]);

        $PO_id = $request->get('id');
        //    - ส่ง Email หาลูกค้า
        $po_masters = DB::select("
            SELECT PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                CUS.customer_type, CUS.payment_type, CUS.email, CUS.flname
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
                and PO.id = ' $PO_id'
        ");
        foreach ($po_masters as $po_master) {
            // 3 สร้าง PO
            $po               = $po_master->PO_Number;
            $flname           = $po_master->flname;
            $PO_date          = $po_master->PO_date;
            $delivery_date    = $this->DateThai($po_master->delivery_from)." ถึง ".$this->DateThai($po_master->delivery_end);

            $str1 = "<p>".$po_master->shipping_flname . " <br>";
            $str1 = $str1.$po_master->shipping_address . "<br>";

            $str1 = $str1.$po_master->shipping_city . " ";
            $str1 = $str1.$po_master->shipping_province . " ";
            $str1 = $str1.$po_master->shipping_zipcode . " ";
            $str1 = $str1."<br>".$po_master->shipping_telephone . " ";
            $delivery_address = $str1;

            //////////////////////////////////////////////////////////
            //::1.
            //////////////////////////////////////////////////////////
            Mail::to($po_master->email)
            ->cc('jiramet@winnerprize.co.th')
            ->bcc('jiramet.c@mail.kmutt.ac.th')
            ->send(new SendMailable_OrderCancel2($po, $flname, $PO_date, $delivery_date, $delivery_address));
        }
    }


    public function create()
    {
        //
    }


    public function store(Request $request)
    {
        //
    }


    public function show($id)
    {
        //
    }

    public function edit($id)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
            return redirect()->route('index.index')->with('success', 'กรุณา Login');
        }
        $customer = customer::where('id', '=', $id)->get();
        return view('Customer.info_edit')->with([
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'customer' => $customer,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);

    }

    public function change_password()     //    ($id, $form_type)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
            return redirect()->route('index.index')->with('success', 'กรุณา Login');
        }
        $customer = customer::where('id', '=', $CookieID_customer)->get();

        return view('Customer.change_password')->with([
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'customer' => $customer,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);

    }

    public function edit_address($id)     //    ($id, $form_type)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
            return redirect()->route('index.index')->with('success', 'กรุณา Login');
        }
        $customer = customer::where('id', '=', $id)->get();

        return view('Customer.info_edit_address')->with([
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'customer' => $customer,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);

    }

    public function update(Request $request, $id)
    {
        if ($request->has('Address')){

            $customer = customer::find($id);
            $customer->billing_flname = $request->get('billing_flname');
            $customer->billing_address = $request->get('billing_address');
            $customer->billing_city = $request->get('billing_city');
            $customer->billing_province = $request->get('billing_province');
            $customer->billing_zipcode = $request->get('billing_zipcode');
            $customer->billing_telephone = $request->get('billing_telephone');

            $customer->shipping_flname = $request->get('shipping_flname');
            $customer->shipping_address = $request->get('shipping_address');
            $customer->shipping_city = $request->get('shipping_city');
            $customer->shipping_province = $request->get('shipping_province');
            $customer->shipping_zipcode = $request->get('shipping_zipcode');
            $customer->shipping_telephone = $request->get('shipping_telephone');
            $customer->save();
            return redirect()->route('Customer.index')->with('success', 'บันทึกข้อมูลเรียบร้อย');

        } else{

            $this->validate(
                $request,
                [

                    'customer_tag' => 'required|min:13',
                    'email' => 'required',
                    'mobile' => 'required|min:9'

                ],
                [
                    'customer_tag.required' => 'กรุณาระบุ เลขที่ผู้เสียภาษี หรือ เลขที่บัตรประชาชน',
                    'customer_tag.min' => 'กรุณาระบุเลขประจำตัวผู้เสียภาษีหรือเลขที่บัตรประชาชนอย่างน้อย 13 หลัก',
                    'email.required' => 'กรุณาระบุ Email เพื่อใช้ในการเข้าระบบ',
                    'email.unique' => 'กรุณาระบุ Email ให้ถูกต้อง',
                    'mobile.required' => 'กรุณาระบุเบอร์โทรศัพท์มือถือ',
                    'mobile.min' => 'กรุณาระบุเบอร์โทรศัพท์มือถือ ตามรูปแบบที่ถูกต้อง '
                ]
            );

            if ($request->get('newsletter')=="รับข่าวสารทาง email"){
              $newsletter="ON";
            }else{
              $newsletter="OFF";
            }

            $customer = customer::find($id);
            $customer->flname = $request->get('flname');
            $customer->mobile = $request->get('mobile');
            $customer->email = $request->get('email');
            $customer->gender = $request->get('gender');
            $customer->birthday = $request->get('birthday');
            $customer->customer_tag = $request->get('customer_tag');
            $customer->shipping_type = $request->get('shipping_type');
            $customer->newsletter = $newsletter;
            /// ห้าม ตรงนี้   $customer->payment_type = $request->get('payment_type');
            $customer->company = $request->get('company');
            $customer->company_tag = $request->get('company_tag');
            $customer->save();
            return redirect()->route('Customer.index')->with('success', 'บันทึกข้อมูลเรียบร้อย');
        }
    }

    public function change_password_update(Request $request)
    {

        if ( ( $request->get( 'current_password') == "" ) || ($request->get('new_password') == "") || ($request->get( 'confirm_new_password') == "" )) {

            $this->get_configuration();
            $customer = customer::where('id', '=',$request->get( 'ID_Customer'))->get();
            return view('Customer.change_password')->with([
                'arr_configuration' => $this->get_configuration(),
                'sess_grandparent_categories' => $this->grandparent_categories(),
                'sess_sub_categories' => $this->sub_categories(),
                'sess_categorie' => $this->sub_concat_categories(),
                'sess_categorie_short' => $this->categories(),
                'customer' => $customer,
                'po_mastermain' => $this->get_po_master($request->get('ID_Customer'))
            ])->with('fail', 'ยืนยันรหัสผ่านใหม่ ไม่ถูกต้อง');

        }


        if ( $request->get('new_password') != $request->get( 'confirm_new_password') ) {

            //return " ยืนยันรหัสผ่านใหม่ ไม่ถูกต้อง ";
            //return redirect()->route('Customer.index')->with('error', 'ยืนยันรหัสผ่านใหม่ ไม่ถูกต้อง');

            $this->get_configuration();
            $customer = customer::where('id', '=',$request->get('ID_Customer'))->get();
            return view('Customer.change_password')->with([
                'arr_configuration' => $this->get_configuration(),
                'sess_grandparent_categories' => $this->grandparent_categories(),
                'sess_sub_categories' => $this->sub_categories(),
                'sess_categorie' => $this->sub_concat_categories(),
                'sess_categorie_short' => $this->categories(),
                'customer' => $customer,
                'po_mastermain' => $this->get_po_master($request->get('ID_Customer'))
            ])->with('fail', 'ยืนยันรหัสผ่านใหม่ ไม่ถูกต้อง');


        }


        $chk_customer = DB::table( 'customers')
            ->where( 'id', '=', $request->get( 'ID_Customer') )
            ->where( 'password', '=', $request->get('current_password'))
            ->count();
        echo $chk_customer;

        //dd($chk_customer);
        if ($chk_customer>0) {
            $customer = customer::find( $request->get('ID_Customer') );
            $customer->password = $request->get('new_password');
            $customer->save();
            return redirect()->route('Customer.index')->with('success', 'บันทึกข้อมูลเรียบร้อย');
        }else{
                $this->get_configuration();
                $customer = customer::where('id', '=', $request->get('ID_Customer'))->get();
                return view('Customer.change_password')->with([
                    'arr_configuration' => $this->get_configuration(),
                    'sess_grandparent_categories' => $this->grandparent_categories(),
                    'sess_sub_categories' => $this->sub_categories(),
                    'sess_categorie' => $this->sub_concat_categories(),
                    'sess_categorie_short' => $this->categories(),
                    'customer' => $customer,
                    'po_mastermain' => $this->get_po_master($request->get('ID_Customer'))
                ])->with('fail', 'ยืนยันรหัสผ่านใหม่ ไม่ถูกต้อง');
        }


    }


    public function destroy($id)
    {
        //
    }

    public function downloadPDF($id)
    {

       //dd( $id);
        $po_master = DB::select("
            SELECT
                PO.PO_date, PO.id, PO.PO_Number, PO.ID_customer, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by,
                PO.Shipping_ref, PO.Shipping_date, PO.Shipping_emp,
                PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,
                CUS.customer_type, CUS.payment_type, CUS.email,CUS.flname, CUS.mobile, CUS.email, CUS.customer_tag, CUS.shipping_type
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.id = $id
        ");
//dd($po_master);
        foreach ($po_master as $data) {
            $PO_Number = $data->PO_Number;
        }
        $po_items = DB::select("
            SELECT
              POI.PO_Number, POI.id, POI.ID_product, POI.product_color, POI.product_name_th,
              POI.Quantity, POI.final_price, POI.total, POI.product_unit, PD.ID_reference
            FROM po_items POI,products PD
            where POI.ID_product=PD.id
            and POI.PO_Number = '$PO_Number'
        ");

        $pdf = PDF::loadView( 'Customer.PO_doc', compact('po_master','po_items'));
        return $pdf->download($PO_Number. ' .pdf');
    }

    public function pdfview($id)
    {
        $id_PO = $id;
        $po_master = DB::select("
            SELECT
                PO.PO_date, PO.id, PO.PO_Number, PO.ID_customer, PO.delivery_from, PO.delivery_end, PO.payment,
                PO.shipping_type, PO.company, PO.ID_tag,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by,
                PO.Shipping_ref, PO.Shipping_date, PO.Shipping_emp,
                PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,
                CUS.customer_type, CUS.payment_type, CUS.email,CUS.flname, CUS.mobile, CUS.email, CUS.customer_tag, CUS.shipping_type
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.id = $id_PO
        ");

        foreach ($po_master as $data) {
            $PO_Number = $data->PO_Number;
        }

        $po_items = DB::select("
            SELECT
              POI.PO_Number, POI.id, POI.ID_product, POI.product_color, POI.product_name_th,
              POI.Quantity, POI.final_price, POI.total, POI.product_unit, PD.ID_reference
            FROM po_items POI,products PD
            where POI.ID_product=PD.id
            and POI.PO_Number = '$PO_Number'
        ");
        return view('Customer.PO_doc')
            ->with(compact('po_items'))
            ->with(compact('po_master'));
    }


    public function PO_doc(Request $request)
    {
        $id_PO = $request->get('id');
        $po_master = DB::select("
            SELECT
                PO.PO_date, PO.id, PO.PO_Number, PO.ID_customer, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by,
                PO.Shipping_ref, PO.Shipping_date, PO.Shipping_emp,
                PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,
                CUS.customer_type, CUS.payment_type, CUS.company, CUS.email, CUS.flname, CUS.mobile, CUS.email, CUS.customer_tag, CUS.shipping_type
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.id = $id_PO
        ");

        //    $Packaging = configuration::where('configuration_name', '=', 'Packaging')->get();
        //    $Shipping = configuration::where('configuration_name', '=', 'Shipping')->get();
        //    $GoodsReceipt = configuration::where('configuration_name', '=', 'GoodsReceipt')->get();

        // $po_master = po_master::where('id', '=', $request->get('id'))->get();
        return view('Customer.PO_doc')
            ->with(compact('po_master'));
        //      ->with(compact('Packaging'))
        //      ->with(compact('Shipping'))
        //      ->with(compact('GoodsReceipt'));
    }


}
