<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use DB;
use Cookie;
use Session;
use App\employees as employee;
use App\customers as customer;
use App\products as product;
use App\pictures as picture;
use App\configurations as configurations;
use App\products_categories as categorie;
use Illuminate\Support\Facades\Mail;
use App\Mail\SendMailForget;
use App\Mail\Profile_registered2;

class MainmenuController extends Controller
{
    public function index()
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type     ="retail";
        }

        $Best_sellers_backdated = $this->get_configuration_by_name('Best_sellers_backdated');
        if ($Best_sellers_backdated==""){
          $Best_sellers_backdated = 31;
        }

        // สินค้าขายดีหน้าละ 6 รายการมี 4 หน้า
        $Best_sellers_Number_List = $this->get_configuration_by_name('Best_sellers_Number_List');
        if ($Best_sellers_Number_List==""){
          $Best_sellers_Number_List = 24;
        }

        // สินค้ามาใหม่หน้าละ 10  รายการมี 4 หน้า (หากเป็นค่าว่างจะเป็น 40 อัตโนมัติ)
        $New_Arrivals_List = $this->get_configuration_by_name('New_Arrivals_List');
        if ($New_Arrivals_List==""){
          $New_Arrivals_List = 40;
        }

        // สินค้าลดราคา หน้าละ 8 รายการมี 4 หน้า
        $Flash_Sale_List = $this->get_configuration_by_name('Flash_Sale_List');
        if ($Flash_Sale_List==""){
          $Flash_Sale_List = 32;
        }


        $banner_product = picture::where('picture_type','banner')
        ->inRandomOrder()
        ->get();

        return view('Mainmenu.index', [
          'sess_grandparent_categories'=> $this->grandparent_categories(),
          'sess_sub_categories' => $this->sub_categories(),
          'sess_categorie' => $this->sub_concat_categories(),
          'sess_categorie_short' => $this->categories(),

          'sub_categories_picture' => $this->sub_categories_picture(),

          'product_list20' => $this->categories(),
          'arr_configuration' => $this->get_configuration(),
          'product_Recent' => $this->get_product_Recent($customer_type,$CookieID_customer),

          'Best_sellers1' => $this->get_Best_sellers($customer_type,1, $Best_sellers_backdated, $Best_sellers_Number_List),
          'Best_sellers2' => $this->get_Best_sellers($customer_type,2, $Best_sellers_backdated, $Best_sellers_Number_List),
          'Best_sellers3' => $this->get_Best_sellers($customer_type,3, $Best_sellers_backdated, $Best_sellers_Number_List),

          'new_arrivals'        => $this-> get_new_arrivals($customer_type, $New_Arrivals_List),
          'single_new_arrivals' =>  $this->get_single_new_arrivals($customer_type),   // Random limit 1

          'flash_sale1' => $this->get_flash_sale($customer_type,1, $Flash_Sale_List),
          'flash_sale2' => $this->get_flash_sale($customer_type,2, $Flash_Sale_List),
          'flash_sale3' => $this->get_flash_sale($customer_type,3, $Flash_Sale_List),
          'flash_sale_countdown' => $this->get_flash_sale_countdown($customer_type,5),
          'banner_product' => $banner_product,

          'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }

    public function contact()
    {
      if (Cookie::get('customer_id') != false) {
          $CookieID_customer = Cookie::get('customer_id');
          $customer_type     = Cookie::get('customer_type');
      } else {
          $CookieID_customer = 0;
          $customer_type     ="retail";
      }

      return view('Mainmenu.contact', [
          'sess_grandparent_categories'=> $this->grandparent_categories(),
          'sess_sub_categories' => $this->sub_categories(),
          'sess_categorie' => $this->sub_concat_categories(),
          'sess_categorie_short' => $this->categories(),
          'product_list20' => $this->categories(),
          'arr_configuration' => $this->get_configuration(),
          'product_Recent' => $this->get_product_Recent($customer_type,$CookieID_customer),

          'po_mastermain' => $this->get_po_master($CookieID_customer)
      ]);
    }

    public function career()
    {
      if (Cookie::get('customer_id') != false) {
          $CookieID_customer = Cookie::get('customer_id');
          $customer_type     = Cookie::get('customer_type');
      } else {
          $CookieID_customer = 0;
          $customer_type     ="retail";
      }
      $career = DB::select("
          SELECT career_details
          FROM career
          where id = 1
      ");

      return view('Mainmenu.career', [
          'sess_grandparent_categories'=> $this->grandparent_categories(),
          'sess_sub_categories' => $this->sub_categories(),
          'sess_categorie' => $this->sub_concat_categories(),
          'sess_categorie_short' => $this->categories(),
          'product_list20' => $this->categories(),
          'arr_configuration' => $this->get_configuration(),
          'product_Recent' => $this->get_product_Recent($customer_type,$CookieID_customer),
          'career'         =>   $career ,
          'po_mastermain' => $this->get_po_master($CookieID_customer)
      ]);
    }

    public function how_to_orders()
    {
      if (Cookie::get('customer_id') != false) {
          $CookieID_customer = Cookie::get('customer_id');
          $customer_type     = Cookie::get('customer_type');
      } else {
          $CookieID_customer = 0;
          $customer_type     ="retail";
      }

      return view('Mainmenu.how_to_orders', [
          'sess_grandparent_categories'=> $this->grandparent_categories(),
          'sess_sub_categories' => $this->sub_categories(),
          'sess_categorie' => $this->sub_concat_categories(),
          'sess_categorie_short' => $this->categories(),
          'product_list20' => $this->categories(),
          'arr_configuration' => $this->get_configuration(),
          'product_Recent' => $this->get_product_Recent($customer_type,$CookieID_customer),

          'po_mastermain' => $this->get_po_master($CookieID_customer)
      ]);
    }

    public function about()
    {
      if (Cookie::get('customer_id') != false) {
          $CookieID_customer = Cookie::get('customer_id');
          $customer_type     = Cookie::get('customer_type');
      } else {
          $CookieID_customer = 0;
          $customer_type     ="retail";
      }

      return view('Mainmenu.about', [
          'sess_grandparent_categories'=> $this->grandparent_categories(),
          'sess_sub_categories' => $this->sub_categories(),
          'sess_categorie' => $this->sub_concat_categories(),
          'sess_categorie_short' => $this->categories(),
          'product_list20' => $this->categories(),
          'arr_configuration' => $this->get_configuration(),
          'product_Recent' => $this->get_product_Recent($customer_type,$CookieID_customer),
          'po_mastermain' => $this->get_po_master($CookieID_customer)
      ]);
    }



    public function modalregister(Request $request)
    {
        // 1. กรณีสมัครใหม่ จาก Modal Form

    //  dd($request->get('newsletter'));

        $this->validate(
            $request,
            [
                'email' => 'required',
                'Fpassword' => 'required|min:6',
                //'birthday' => 'required',
                'flname' => 'required',
                //'gender' => 'required',
                'mobile' => 'required'
            ],
            [
                'email.required' => 'กรุณาระบุ Email เพื่อใช้ในการเข้าระบบ',
                'email.unique' => 'กรุณาระบุ Email ให้ถูกต้อง',
                'password.required' => 'กรุณาระบุ Password',
                'password.min' => 'กรุณาระบุ Email ให้ถูกต้องอย่งน้อย 6 อักษร',
                'flname.required' => 'กรุณาระบุ ชื่อ-สกุล ของท่าน',
                'mobile.required' => 'กรุณาระบุ เบอร์โทรศัพท์ ของท่าน'
            ]

        );

        if ($request->get('email')==''){
            return 'Error Email';
        }


        /* ตรวจสอบชื่อในระบบ ว่าเคยสมัครหรือไม่
            1.1 ถ้าเคยสมัคร --> สำเร็จ --> แสดง Dialog ส่ง Password ไปที่ Email แล้ว
                          --> คลิก Link ใน Email จะเป็นการตั้ง Password และเข้าระบบเลย + Log
            1.2 ถ้าเคยสมัคร --> ไม่สำเร็จ --> มีอย่างเดียว คือ ไม่ Verify แสดงหน้ากรอกข้อมูลต่อ Dialog ส่ง Password
                          --> ส่งรหัส Verify ไปที่ Email  --> ส่ง Link ไปที่ Email ไม่ต้อง Verify แล้ว
                          --> คลิก Link ใน Email จะเป็นการตั้ง Password และเข้าระบบเลย
                          --> ส่ง Email ขอบคุณ + วิธีใช้งาน
            2. สมัครครั้งแรก --> บันทึกสำเร็จ --> เข้าหน้าสินค้า + Log
                          --> ส่ง Email ขอบคุณ + วิธีใช้งาน

         */
        $customer = customer::where('email', '=', $request->get('email'))
           // ->where('password', '=', $request->get('password'))
            ->get();

        if (count($customer) > 0) {
            //foreach ($customer as $user) {
               // $customer_id = $user->id;
            //}
            $status = 0;
            return 'Have Email';   // ไม่สามารถใช้ Email รหัสนี้ได้
        } else {

            //////////////////////////////////////////////////////////////
            // 2. สมัครครั้งแรก --> บันทึกสำเร็จ --> เข้าหน้าสินค้า + Log
            //     --> ส่ง Email ขอบคุณ + วิธีใช้งาน
            $customer = new customer(
                [
                    'email' => $request->get('email'),
                    'password' => $request->get('Fpassword'),
                    'birthday' => $request->get('birthday'),
                    'flname' => $request->get('flname'),
                    'gender' => $request->get('gender'),
                    'mobile' => $request->get('mobile'),
                    'newsletter' => $request->get('newsletter')
                ]
            );
            $customer->save();

            //////////////////////////////////////////////////////////////
            // 3. ตรวจสอบการบันทึก และ หารหัสลูกค้า และ บันทึก Log สร้าง Cookie และ Session
            //////////////////////////////////////////////////////////////
            $customer_new = customer::where('email', '=', $request->get('email'))
                 ->where('password', '=', $request->get('Fpassword'))
                 ->get();

            if (count($customer_new) > 0) {
                foreach ($customer_new as $user) {
                    $this->customer_id   = $user->id;
                    $this->customer_type = $user->customer_type;
                    $this->gender        = $user->gender;
                    $this->flname        = $user->flname;
                    $this->mobile        = $user->mobile;
                    $this->email         = $user->email;
                    $this->birthday      = $user->birthday;
                    $this->newsletter    = $user->newsletter;
                    //$Login_id = $user->Login_id;
                    //$email_confirm_id = $user->email_confirm_id;
                    //$email_confirm = $user->email_confirm;
                }
                $this->status = 1;
                $this->description = 'ลงทะเบียนใหม่สำเร็จ';
                $this->SaveLogmain();
                $this->SaveCookiemain();

                $path_image_system = $this->get_configuration_by_name('path_image_system');
                $email_admin_all = $this->get_configuration_by_name('email_admin_all');
                Mail::to($this->email)
                ->bcc($email_admin_all)
                ->send(new Profile_registered2($this->flname,$path_image_system));
                return 'OK';

            }

        }
    }

    public function modallogin(Request $request)
    {

        $this->Lifetime_Front_cookies    = $this->get_configuration_by_name('Lifetime_Front_cookies');
        $this->email = $request->get('email');
        $this->password = $request->get('password');

        $customer = customer::where('email', '=', $request->get('email'))
            ->where('password', '=', $request->get('password'))
            ->get();

        if (count($customer) > 0) {
            foreach ($customer as $user) {

                $this->customer_id   = $user->id;
                $this->customer_type = $user->customer_type;
                $this->gender        = $user->gender;
                $this->flname        = $user->flname;
                $this->mobile        = $user->mobile;
          //      $this->email         = $user->email;

                $email_confirm_id = $user->email_confirm_id;
                $email_confirm = $user->email_confirm;
                $this->birthday = $user->birthday;

                $this->status = 1;
                $this->description = 'ปกติ';
                $this->description = $user->customer_type;

                $this->SaveLogmain();
                $this->SaveCookiemain();
                $this->summary_cart($this->customer_id);
                //dd($this->customer_type);

                //dd( $user->customer_type);
            }

        } else {
            $this->status = 0;
            $this->description = 'รหัสผ่านไม่ถูกต้อง';
            $this->SaveLogmain();
            return 'รหัสผ่านไม่ถูกต้อง';
        }
    }


    public function modalforget(Request $request)
    {
        //   dd( $request->get('email'));
        $customer = customer::where('email', '=', $request->get('email'))
          //  ->where('password', '=', $request->get('password'))
            ->get();
        if (count($customer) > 0) {
            foreach ($customer as $user) {

                $this->customer_id   = $user->id;
                $this->customer_type = $user->customer_type;
                $this->gender        = $user->gender;
                $this->flname        = $user->flname;
                $this->mobile        = $user->mobile;

                $email_confirm_id = $user->email_confirm_id;
                $email_confirm = $user->email_confirm;
                $this->birthday = $user->birthday;

                $this->status = 1;
                $this->description = 'ปกติ';
                $this->description = $user->customer_type;
                $this->SaveLogmain();
                // ส่ง Pawword : Email
                Mail::to( $request->get('email'))
              //      ->bcc('cs@winnerprize.co.th')
                    ->send(new SendMailForget( $user->password, $user->flname));
            }
        } else {
            $this->status = 0;
            $this->description = 'Forget Password : Eamil ไม่ถูกต้อง';
            $this->SaveLogmain();
            return 'ไม่ถูกต้อง';
        }
    }


    public function create()
    {
        return view('layouts.MainLeft');
    }

    public function blank()
    {
        return view('layouts.blank');
    }

    public function MainLeft()
    {
        return view('layouts.MainLeft');
    }

    public function AllValue()
    {

        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
        }

        return view( 'layouts.AllValue', [

            'sess_grandparent_categories'=> $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration(),
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }


        public function main_full()
    {
        return view('layouts.main_full');
    }


    public function store(Request $request)
    {
        //
    }


    public function show($id)
    {
        //
    }


    public function edit($id)
    {
        //
    }


    public function update(Request $request, $id)
    {
        //
    }

    public function destroy($id)
    {
        //
    }
}
