<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use Cookie;
use Session;
use App\products as product;
use App\products_categories as categorie;
use App\products_likes as products_like;
use App\products_recents as products_recents;
use App\customers as customer;

use Illuminate\Broadcasting\PrivateChannel;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\File;

use Illuminate\Support\Facades\URL;

use App\log_logins as log_login;

use phpDocumentor\Reflection\Types\This;

use getClientIps;


class ProductController extends Controller
{

    function get_client_ip()
    {
        $ipaddress = '';
        if (isset($_SERVER['HTTP_CLIENT_IP']))
            $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
        else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_X_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
        else if (isset($_SERVER['HTTP_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_FORWARDED'];
        else if (isset($_SERVER['REMOTE_ADDR']))
            $ipaddress = $_SERVER['REMOTE_ADDR'];
        else
            $ipaddress = 'UNKNOWN';
        return $ipaddress;
    }



    public function product_addlike(Request $request)
    {
      if (Cookie::get('customer_id') != false) {
          $CookieID_customer = Cookie::get('customer_id');
      } else {
          $CookieID_customer = 0;
      }

        // ตรวจสอบว่่ามีการ Like หรือยัง
        $chk_products_like = products_like::where('ID_customer', '=', $CookieID_customer)
            ->where('ID_product', '=', $request->get('ID_product'))
            ->get();
        if (count($chk_products_like) > 0) {
            // ลบ Like
            DB::table('products_likes')
                ->where('ID_customer', '=', $CookieID_customer)
                ->where('ID_product', '=', $request->get('ID_product'))
                ->delete();
        }else{
            // บันทึก Like
            $products_like = new products_like(
                [
                    'ID_customer' => $CookieID_customer,
                    'ID_product' => $request->get('ID_product')
                ]
            );
            $products_like->save();
        }
    }



    public function product_addlike_only(Request $request)
    {
      if (Cookie::get('customer_id') != false) {
          $CookieID_customer = Cookie::get('customer_id');
      } else {
          $CookieID_customer = 0;
      }
        // ตรวจสอบว่่ามีการ Like หรือยัง
        $chk_products_like = products_like::where('ID_customer', '=', $CookieID_customer)
            ->where('ID_product', '=', $request->get('ID_product'))
            ->get();
        if (count($chk_products_like) > 0) {
            // ลบ Like
            // DB::table('products_likes')
            //     ->where('ID_customer', '=', $CookieID_customer)
            //     ->where('ID_product', '=', $request->get('ID_product'))
            //     ->delete();
        }else{
            // บันทึก Like
            $products_like = new products_like(
                [
                    'ID_customer' => $CookieID_customer,
                    'ID_product' => $request->get('ID_product')
                ]
            );
            $products_like->save();
        }
    }


    public function products_addrecent($ID_customer, $ID_product)
    {
        if ($ID_customer==""){
            $ID_customer=0;
        }

        if ($ID_product!=""){

            // ตรวจสอบว่่ามีการ add recent หรือยัง
            $chk_products_recent = products_recents::where('ID_customer', '=', $ID_customer)
                ->where('ID_product', '=', $ID_product)
                ->get();
            if (count($chk_products_recent) > 0) {
                // ลบ Like
                foreach ( $chk_products_recent as $chk_products_recent){
                    $maxhit = $chk_products_recent->hit;
                    $maxhit = $maxhit + 1;
                }
                DB::table('products_recents')
                    ->where('ID_customer', '=', $ID_customer)
                    ->where('ID_product', '=', $ID_product)
                    ->update([
                         'hit' => $maxhit
                ]);

            }else{
                // บันทึกรายการใหม่
                $products_recents = new products_recents(
                    [
                        'ID_customer' => $ID_customer,
                        'ID_product' => $ID_product,
                        'hit' => 1
                    ]
                );
                $products_recents->save();
            }
        }

    }

    public function index()
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
        }
        //$this->get_configuration();
        $product_list20 = product::where('product_name_th', 'like', '%%')
            ->where('enable', '=', 'ON')
            ->orderBy('product_name_th', 'ASC')
            ->take(20)
            ->get();

        return view('Product.product', [
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $product_list20,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type = "retail";
        }
        $product_list20 = DB::select("
            SELECT *
            FROM `products`
            where (enable = 'ON') and (
                  product_name_th like '%$id%'
                  or description_brief like '%$id%'
                  or ID_reference like '%$id%'
            )
            ORDER BY `ID_categories`, `product_name_th`
        ");

        return view('Product.product', [
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $product_list20,
            'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }

    public function product_search(Request $request)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type = "retail";
        }
         if ($request->search=="ALL") { $request->search=""; }

        $Product_Search_List = $this->get_configuration_by_name('Product_Search_List');
        if ($Product_Search_List==""){
          $Product_Search_List=50;
        }
        $input_search_name=$request->search;

        $search_category  = DB::select( "

             SELECT products_categories.id, products_categories.categories, count(products.product_name_th) as countproduct
             FROM products, products_categories
             where products.ID_categories=products_categories.id
             and  (products.enable = 'ON')
             and
                 (    products.product_name_th like '%$request->search%'
                     or products.description_brief like '%$request->search%'
                     or products.ID_reference like '%$request->search%'

                 )
             GROUP BY products_categories.id, products_categories.categories
             ORDER BY products_categories.categories

         ");

        $search_category  = DB::select( "

            SELECT products_categories.id, products_categories.categories, count(products.product_name_th) as countproduct
            FROM products, products_categories
            where products.ID_categories=products_categories.id
            and  (products.enable = 'ON')
            and
                (    products.product_name_th like '%$request->search%'
                    or products.description_brief like '%$request->search%'
                    or products.ID_reference like '%$request->search%'

                )
            GROUP BY products_categories.id, products_categories.categories
            ORDER BY products_categories.categories

        ");

        if ( ($customer_type == "wholesale") || ($customer_type == "salesman") ) {

          $product_search = DB::table('products')
            ->where(function($query) use ($input_search_name) {
                $query->where('product_name_th', 'like', '%' . $input_search_name . '%')
                ->orWhere('description_brief', 'like', '%' . $input_search_name . '%')
                ->orWhere('ID_reference', 'like', '%' . $input_search_name . '%');
            })
            ->where('enable', 'like', '%' . $request->ID_categories . '%')
            ->where('ID_categories', 'like', '%' . $request->ID_categories . '%')
            ->where('enable','ON')
            ->select(
                'products.id','products.ID_reference',
                'products.product_name_th',
                'products.picture_path',
                'products.wholesale_price as price',
                'products.wholesale_discount as discount',
                'products.new_arrivals',

                \DB::raw('(case
                WHEN wholesale_discount_dateStart <= now()
                    and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN wholesale_price - wholesale_discount
                    else wholesale_price
                END) as final_price'),

                \DB::raw('(case
                WHEN wholesale_price > 0
                    and wholesale_discount_dateStart <= now()
                    and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN  wholesale_discount * 100 / wholesale_price
                    else 0
                END) as discount_percent'))

            ->orderby('ID_categories', 'ASC')
            ->orderby('product_name_th', 'ASC')
            ->paginate($Product_Search_List);

        } else {
            ////////   Retail    ////////
            //echo $admin_list_per_page;
            $product_search = DB::table('products')
              ->where(function($query) use ($input_search_name) {
                  $query->where('product_name_th', 'like', '%' . $input_search_name . '%')
                  ->orWhere('description_brief', 'like', '%' . $input_search_name . '%')
                  ->orWhere('ID_reference', 'like', '%' . $input_search_name . '%');
              })
              ->where('ID_categories', 'like', '%' . $request->ID_categories . '%')
              ->where('enable','ON')
              ->select(
                  'products.id','products.ID_reference',
                  'products.product_name_th',
                  'products.picture_path',
                  'products.retail_price as price',
                  'products.retail_discount as discount',
                  'products.new_arrivals',

                  \DB::raw('(case
                  WHEN retail_discount_dateStart <= now()
                      and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                  THEN retail_price - retail_discount
                      else retail_price
                  END) as final_price'),

                  \DB::raw('(case
                  WHEN retail_price > 0
                      and retail_discount_dateStart <= now()
                      and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                  THEN  retail_discount * 100 / retail_price
                      else 0
                  END) as discount_percent'))

              ->orderby('ID_categories', 'ASC')
              ->orderby('product_name_th', 'ASC')
              ->paginate($Product_Search_List);
        }
        //dd($product_list20);
        return view('Product.product', [
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_search' => $product_search,
            'search_category' => $search_category,
            'search' => $request->search,
            'search_found' => $product_search->total(),
            'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }



    public function product_search2(Request $request)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type = "retail";
        }



        if ($request->search=="ALL") { $request->search=""; }

        $Product_Search_List = $this->get_configuration_by_name('Product_Search_List');
        if ($Product_Search_List==""){
          $Product_Search_List=50;
        }

        $input_search_name=$request->search;

          $search_category  = DB::select("

            SELECT products_categories.id, products_categories.categories, count(products.product_name_th) as countproduct
            FROM products, products_categories
            where products.ID_categories=products_categories.id
            and  (products.enable = 'ON')
            and
                (    products.product_name_th like '%$request->search%'
                    or products.description_brief like '%$request->search%'
                    or products.ID_reference like '%$request->search%'

                )
            GROUP BY products_categories.id, products_categories.categories
            ORDER BY products_categories.categories

        ");
        //dd( $customer_type);
        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {

          $product_search = DB::table('products')
            ->where(function($query) use ($input_search_name) {
                $query->where('product_name_th', 'like', '%' . $input_search_name . '%')
                ->orWhere('description_brief', 'like', '%' . $input_search_name . '%')
                ->orWhere('ID_reference', 'like', '%' . $input_search_name . '%');
            })
            ->where('ID_categories',$request->ID_categories)
            ->where('enable','ON')
            ->select(
                'products.id','products.ID_reference',
                'products.product_name_th',
                'products.picture_path',
                'products.wholesale_price as price',
                'products.wholesale_discount as discount',
                'products.new_arrivals',

                \DB::raw('(case
                WHEN wholesale_discount_dateStart <= now()
                    and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN wholesale_price - wholesale_discount
                    else wholesale_price
                END) as final_price'),

                \DB::raw('(case
                WHEN wholesale_price > 0
                    and wholesale_discount_dateStart <= now()
                    and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN  wholesale_discount * 100 / wholesale_price
                    else 0
                END) as discount_percent'))

            ->orderby('ID_categories', 'ASC')
            ->orderby('product_name_th', 'ASC')
            ->paginate($Product_Search_List);

        } else {
            ////////   Retail    ////////
            $product_search = DB::table('products')
              ->where(function($query) use ($input_search_name) {
                  $query->where('product_name_th', 'like', '%' . $input_search_name . '%')
                  ->orWhere('description_brief', 'like', '%' . $input_search_name . '%')
                  ->orWhere('ID_reference', 'like', '%' . $input_search_name . '%');
              })

              ->where('ID_categories',$request->ID_categories)
              ->where('enable','ON')
              ->select(
                  'products.id','products.ID_reference',
                  'products.product_name_th',
                  'products.picture_path',
                  'products.retail_price as price',
                  'products.retail_discount as discount',
                  'products.new_arrivals',

                  \DB::raw('(case
                  WHEN retail_discount_dateStart <= now()
                      and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                  THEN retail_price - retail_discount
                      else retail_price
                  END) as final_price'),

                  \DB::raw('(case
                  WHEN retail_price > 0
                      and retail_discount_dateStart <= now()
                      and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                  THEN  retail_discount * 100 / retail_price
                      else 0
                  END) as discount_percent'))

              ->orderby('ID_categories', 'ASC')
              ->orderby('product_name_th', 'ASC')
              ->paginate($Product_Search_List);
        }

        return view('Product.product', [
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'search_category' => $search_category,
            'search' => $request->search,
            'product_search' => $product_search,
            'search_found' => $product_search->total(),
            'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }


    public function product_search3($sub_categories)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type = "retail";
        }

        $Product_Search_List = $this->get_configuration_by_name('Product_Search_List');
        if ($Product_Search_List==""){
          $Product_Search_List=50;
        }

        $search_category  = DB::select("

            SELECT products_categories.id, products_categories.categories, count(products.product_name_th) as countproduct
            FROM products, products_categories
            where products.ID_categories=products_categories.id
            and  (products.enable = 'ON')
            GROUP BY products_categories.id, products_categories.categories
            ORDER BY products_categories.categories

        ");

        if (($customer_type == "wholesale") || ($customer_type == "salesman")) {

          $product_search = DB::table('products')
            ->whereIn('ID_categories', function($query) use ($sub_categories){
                $query->select('id')
                      ->from('products_categories')
                      ->where('sub_categories', $sub_categories);
            })
            ->where('enable','ON')
            ->select(
                'products.id','products.ID_reference',
                'products.product_name_th',
                'products.picture_path',
                'products.wholesale_price as price',
                'products.wholesale_discount as discount',
                'products.new_arrivals',

                \DB::raw('(case
                WHEN wholesale_discount_dateStart <= now()
                    and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN wholesale_price - wholesale_discount
                    else wholesale_price
                END) as final_price'),

                \DB::raw('(case
                WHEN wholesale_price > 0
                    and wholesale_discount_dateStart <= now()
                    and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN  wholesale_discount * 100 / wholesale_price
                    else 0
                END) as discount_percent'))

            ->orderby('ID_categories', 'ASC')
            ->orderby('product_name_th', 'ASC')
            ->paginate($Product_Search_List);

        } else {
            ////////   Retail    ////////

            $product_search = DB::table('products')
              ->whereIn('ID_categories', function($query) use ($sub_categories){
                  $query->select('id')
                        ->from('products_categories')
                        ->where('sub_categories', $sub_categories);
              })
              ->where('enable','ON')
              ->select(
                  'products.id','products.ID_reference',
                  'products.product_name_th',
                  'products.picture_path',
                  'products.retail_price as price',
                  'products.retail_discount as discount',
                  'products.new_arrivals',

                  \DB::raw('(case
                  WHEN retail_discount_dateStart <= now()
                      and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                  THEN retail_price - retail_discount
                      else retail_price
                  END) as final_price'),

                  \DB::raw('(case
                  WHEN retail_price > 0
                      and retail_discount_dateStart <= now()
                      and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                  THEN  retail_discount * 100 / retail_price
                      else 0
                  END) as discount_percent'))

              ->orderby('ID_categories', 'ASC')
              ->orderby('product_name_th', 'ASC')
              ->paginate($Product_Search_List);

        }

        return view('Product.product', [
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
          //  'product_list20' => $product_list20,
            'search_category' => $search_category,
          //  'search_found' => count($product_list20),

            'product_search' => $product_search,
            'search_found' => $product_search->total(),

            'search' => "ALL",
            'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }


        public function product_wishlist($sub_categories)
        {

          if (Cookie::get('customer_id') != false) {
              $CookieID_customer = Cookie::get('customer_id');
              $customer_type = Cookie::get('customer_type');
          } else {
              $CookieID_customer = 0;
              $customer_type = "retail";
          }

          if ($sub_categories='All'){
            $condition_sub_categories = " ";
          }else{
            $condition_sub_categories = " ->where('ID_categories',$sub_categories) ";

          }

          $Product_Search_List = $this->get_configuration_by_name('Product_Search_List');
          if ($Product_Search_List==""){
            $Product_Search_List=50;
          }

            $search_category  = DB::select("

                SELECT PC.id, PC.categories,
                        count(PD.product_name_th)  as countproduct
                FROM products_likes PL, products PD, products_categories PC
                where
                        PL.ID_product=PD.id
                  and   PD.ID_categories=PC.id
                  and   PD.enable = 'ON'
                  and   PL.ID_customer= $CookieID_customer
                GROUP BY PC.id, PC.categories
                ORDER BY PC.categories
            ");

            //echo $request->get('ID_categories');
          //  echo "sub_categories = > ".$sub_categories;


            if (($customer_type == "wholesale") || ($customer_type == "salesman")) {


                  $product_search = DB::table('products')
                  ->where('products.enable','ON')
                  ->where('products_likes.ID_customer',$CookieID_customer)
                  ->join('products_likes', 'products.id', '=', 'products_likes.ID_product')
                  ->select(
                      'products.id','products.ID_reference',
                      'products.product_name_th',
                      'products.picture_path',
                      'products.wholesale_price as price',
                      'products.wholesale_discount as discount',
                      'products.new_arrivals',

                      \DB::raw('(case
                      WHEN wholesale_discount_dateStart <= now()
                          and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                      THEN wholesale_price - wholesale_discount
                          else wholesale_price
                      END) as final_price'),

                      \DB::raw('(case
                      WHEN wholesale_price > 0
                          and wholesale_discount_dateStart <= now()
                          and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                      THEN  wholesale_discount * 100 / wholesale_price
                          else 0
                      END) as discount_percent'))

                  ->orderby('ID_categories', 'ASC')
                  ->orderby('product_name_th', 'ASC')
                  ->paginate($Product_Search_List);


            } else {
                ////////   Retail    ////////
                $product_search = DB::table('products')
                ->where('products.enable','ON')
                ->where('products_likes.ID_customer',$CookieID_customer)
                ->join('products_likes', 'products.id', '=', 'products_likes.ID_product')
                ->select(
                    'products.id','products.ID_reference',
                    'products.product_name_th',
                    'products.picture_path',
                    'products.retail_price as price',
                    'products.retail_discount as discount',
                    'products.new_arrivals',

                    \DB::raw('(case
                    WHEN retail_discount_dateStart <= now()
                        and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN retail_price - retail_discount
                        else retail_price
                    END) as final_price'),

                    \DB::raw('(case
                    WHEN retail_price > 0
                        and retail_discount_dateStart <= now()
                        and DATE_ADD(retail_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN  retail_discount * 100 / retail_price
                        else 0
                    END) as discount_percent'))

                ->orderby('ID_categories', 'ASC')
                ->orderby('product_name_th', 'ASC')
                ->paginate($Product_Search_List);

            }

            //dd($product_list20);

            return view('Product.product', [
                'arr_configuration' => $this->get_configuration(),
                'sess_grandparent_categories' => $this->grandparent_categories(),
                'sess_sub_categories' => $this->sub_categories(),
                'sess_categorie' => $this->sub_concat_categories(),
                'sess_categorie_short' => $this->categories(),
            //    'product_list20' => $product_list20,

                'product_search' => $product_search,
                'search_found' => $product_search->total(),

                'search_category' => $search_category,
                'search' => "ALL",
            //    'search_found' => count($product_list20),
                'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
                'po_mastermain' => $this->get_po_master($CookieID_customer)
            ]);
        }




    public function product_search_categorie(Request $request)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type     = "retail";
        }

        $product_list20 = DB::select("

            SELECT * FROM
            products
            where ID_categories
            in (
                SELECT id FROM
                products_categories
                where categories='$request->search'
            )
            ORDER BY `ID_categories`, `product_name_th`
        ");


        return view('Product.product', [
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $product_list20,
            'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
            'po_mastermain' => $this->get_po_master($CookieID_customer)

        ]);
    }

    public function product_search_parent(Request $request)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type     = "retail";
        }

        $product_list20 = DB::select("
            SELECT * FROM
            products
            where ID_categories
            in (
                SELECT id FROM
                products_categories
                where categories_parent = (
                    SELECT position FROM products_categories where categories='$request->search'
                )
            )
            ORDER BY `ID_categories`, `product_name_th`
        ");
        return view('Product.product', [
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $product_list20,
            'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);
    }

    public function product_view($id)
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
            $customer_type     = Cookie::get('customer_type');
        } else {
            $CookieID_customer = 0;
            $customer_type     = "retail";
        }

        // Seve Recent
        $this->products_addrecent($CookieID_customer, $id);

        // รูปสินค้า
        $picture_list = DB::select("
            SELECT  p.picture_path, p.id, pp.description, pp.ID_product
            FROM   `products_pictures` pp, `pictures` p
            where    pp.ID_picture=p.id
                and  pp.enable=\"ON\"
                and  pp.ID_product='$id'
        ");

        $product_view = $this->get_product_view($id);

        foreach ($product_view as $value) {
          $PP_PS_PC = $this->find_grandparent_categories($value->id_categorie);

          if ($value->picture_color!=0){
            $picture_color_path  = $this->get_path_picture($value->picture_color);
          }else{
            $picture_color_path  = "";
          }

          if ($value->picture_trademark!=0){
            $picture_trademark_path  = $this->get_path_picture($value->picture_trademark);
          }else{
            $picture_trademark_path  = "";
          }


        }

       return view('Product.product_view', [
            'PP_PS_PC' => $PP_PS_PC,
            'arr_configuration' => $this->get_configuration(),
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_view' => $product_view,

            'picture_color_path' => $picture_color_path,
            'picture_trademark_path' => $picture_trademark_path,            

            'picture_list' => $picture_list,
            'product_like' => $this->product_checklike($id, $CookieID_customer),
            'product_Recent' => $this->get_product_Recent($customer_type, $CookieID_customer),
            'po_mastermain' => $this->get_po_master($CookieID_customer)

        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }


}
