<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use Event;
use DB;
use Input;
use Cookie;
use App\log_logins as log_login;
use App\employees as employee;
use App\customers as customer;


class registerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $this->get_configuration();
        return view('Register.register', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration()
        ]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // 1. กรณีสมัครใหม่ จาก Modal Form
        $this->validate($request, [
            'email' => 'required',
            'password' => 'required|min:6',

    //        'birthday' => 'required',
            'flname' => 'required',
    //        'gender' => 'required',
            'mobile' => 'required'
        ],
        [
            'email.required' => 'กรุณาระบุ Email เพื่อใช้ในการเข้าระบบ',
            'email.unique' => 'กรุณาระบุ Email ให้ถูกต้อง',
            'password.required' => 'กรุณาระบุ Password',
            'password.min' => 'กรุณาระบุ Email ให้ถูกต้องอย่งน้อย 6 อักษร',
            'flname.required' => 'กรุณาระบุ ชื่อ-สกุล ของท่าน',
            'mobile.required' => 'กรุณาระบุ เบอร์โทรศัพท์ ของท่าน'
        ]

        );


        /* ตรวจสอบชื่อในระบบ ว่าเคยสมัครหรือไม่
            1.1 ถ้าเคยสมัคร --> สำเร็จ --> แสดง Dialog ส่ง Password ไปที่ Email แล้ว
                          --> คลิก Link ใน Email จะเป็นการตั้ง Password และเข้าระบบเลย + Log
            1.2 ถ้าเคยสมัคร --> ไม่สำเร็จ --> มีอย่างเดียว คือ ไม่ Verify แสดงหน้ากรอกข้อมูลต่อ Dialog ส่ง Password
                          --> ส่งรหัส Verify ไปที่ Email  --> ส่ง Link ไปที่ Email ไม่ต้อง Verify แล้ว
                          --> คลิก Link ใน Email จะเป็นการตั้ง Password และเข้าระบบเลย
                          --> ส่ง Email ขอบคุณ + วิธีใช้งาน
            2. สมัครครั้งแรก --> บันทึกสำเร็จ --> เข้าหน้าสินค้า + Log
                          --> ส่ง Email ขอบคุณ + วิธีใช้งาน

         */
        $customer = customer::where('email', '=', $request->get('email'))
           // ->where('password', '=', $request->get('password'))
            ->get();

        if (count($customer) > 0) {
            foreach ($customer as $user) {

                $customer_id = $user->id;
                $customer_type = $user->customer_type;
                $gender = $user->gender;
                $flname = $user->flname;
                $mobile = $user->mobile;
                $email = $user->email;
                $Login_id = $user->Login_id;
                $email_confirm_id = $user->email_confirm_id;
                $email_confirm = $user->email_confirm;
                $birthday = $user->birthday;

            }
            $status = 1;


            if ($email_confirm == 'YES'){
                $status = 0;
                // 1.1 ถ้าเคยสมัคร --> สำเร็จ --> แสดง Dialog ส่ง Password ไปที่ Email แล้ว
                //      --> คลิก Link ใน Email จะเป็นการตั้ง Password และเข้าระบบเลย + Log

                return redirect()->route('register.index')->with('fail', 'Email นี้มีในระบบแล้ว');
                // ส่ง Email ไปที่ Email >>>> การ Activate
                // ส่ง Email ไปที่ Email >>>> การ Activate
                // ส่ง Email ไปที่ Email >>>> การ Activate
            }else{
                $status = 0;
                // 1.2 ถ้าเคยสมัคร --> ไม่สำเร็จ --> มีอย่างเดียว คือ ไม่ Verify แสดงหน้ากรอกข้อมูลต่อ Dialog ส่ง Password
                //   --> ส่งรหัส Verify ไปที่ Email --> ส่ง Link ไปที่ Email ไม่ต้อง Verify แล้ว
                //    --> คลิก Link ใน Email จะเป็นการตั้ง Password และเข้าระบบเลย
                //    --> ส่ง Email ขอบคุณ + วิธีใช้งาน

                return redirect()->route('register.index')->with('fail', 'Email นี้มีในระบบแล้ว');
                // ส่ง Email ไปที่ Email >>>> การ Activate
                // ส่ง Email ไปที่ Email >>>> การ Activate
                // ส่ง Email ไปที่ Email >>>> การ Activate
            }

        } else {


            // 2. สมัครครั้งแรก --> บันทึกสำเร็จ --> เข้าหน้าสินค้า + Log
            //     --> ส่ง Email ขอบคุณ + วิธีใช้งาน
            $customer = new customer(
                [
                    'email' => $request->get('email'),
                    'password' => $request->get('password'),
                    'birthday' => $request->get('birthday'),
                    'flname' => $request->get('flname'),
                    'gender' => $request->get('gender'),
                    'mobile' => $request->get('mobile')
                ]
            );
            $customer->save();
            $status = 1;
        }

        $log_logins = new log_login(
            [
                'email' => $request->get('email'),
                'password' => $request->get('password'),
                'status' => $status
            ]
        );
        $log_logins->save();


        if ($status == 1) {
            echo " Set Cookie ";
            echo " ต้องไปหน้ากรอกข้อมูลเพิ่มเติม ";

            // Cookie::queue(Cookie::make('name', 'value', $minutes));
            $this->Lifetime_Front_cookies    = $this->get_configuration_by_name('Lifetime_Front_cookies')*1140;
            Cookie::queue('customer_id', $this->customer_id,              $this->Lifetime_Front_cookies);
            Cookie::queue('customer_name', $request->get('flname'),       $this->Lifetime_Front_cookies);
            Cookie::queue('customer_email', $request->get('email'),       $this->Lifetime_Front_cookies);
            Cookie::queue('customer_password', $request->get('password'), $this->Lifetime_Front_cookies);
            Cookie::queue('customer_birthday', $request->get('birthday'), $this->Lifetime_Front_cookies);
            Cookie::queue('customer_gender', $request->get('gender'),     $this->Lifetime_Front_cookies);
            Cookie::queue('customer_mobile', $request->get('mobile'),     $this->Lifetime_Front_cookies);
            return redirect()->route('index.index')->with('success', 'บันทึกข้อมูลเรียบร้อย');
        } else {
            return redirect()->route('register.index')->with('fail', 'Email หรือ รหัสผ่านไม่ถูกต้อง ! กรุณาลองใหม่ (R)');
            //return view('Authorization.login');//->with('fail', 'ข้อมูลไม่ถูกต้อง');
        }
    }

    /**
             * Display the specified resource.
             *
             * @param  int  $id
             * @return \Illuminate\Http\Response
             */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
