<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use Cookie;
use Session;
use App\customers as customer;
use App\configurations as configurations;

use App\products_categories as categorie;
use App\products_likes as products_like;
use App\products as product;
use App\log_logins as log_login;

use App\po_master as po_master;
use App\po_items as po_items;

use App\pictures as picture;

use Illuminate\Support\Facades\Mail;
use App\Mail\SendMailable;

use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;


use App\pr as pr;




class wholesaleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index_()
    {

    }

    public function index()
    {
        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
            return redirect()->route('Mainmenu.index')->with('', 'กรุณา Login ');
        }

        // 1. Show Customer Profile
        $this->get_configuration();
        $customer = customer::where('id', '=',$CookieID_customer)->get();


        //////////////////////////////////////////////////////////
        // 2. Show PO ถ้ามี
        $po_masters = DB::select("
        
            SELECT PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode, 
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode, 
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status, PO.payment_image,


                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by, PO.Shipping_ref, 
                PO.Shipping_date, PO.Shipping_emp, PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,PO.updated_at     
    

            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id          
              and PO.ID_customer = $CookieID_customer                        
            
        ");

        return view( 'wholesale.PO_wholesale', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration(),
            'po_masters' => $po_masters,
            'customer' => $customer,
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        

        ]);

    }

    
    public function wholesale_Add_PO()
    {

        if (Cookie::get('customer_id') != false) {
            $CookieID_customer = Cookie::get('customer_id');
        } else {
            $CookieID_customer = 0;
            return redirect()->route('Mainmenu.index')->with('', 'กรุณา Login ');
        }

        $pr_list = DB::select("
            SELECT
                PR.id, PR.ID_customer, PR.ID_product, PR.product_color, PR.Quantity, PR.Customer_Select,
                PD.ID_reference, PD.ID_categories, PD.product_name_th, PD.description_brief, PD.product_unit,
                PD.picture_path, PD.shipping_weight, PD.wholesale_price, PD.wholesale_discount,
                PD.wholesale_discount_percent, 
                case
                WHEN wholesale_discount_dateStart <= now()
                and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN wholesale_price - wholesale_discount
                else wholesale_price
                END as wholesale_update_final_price

            FROM prs PR, products PD
            where PR.ID_product = PD.id     
            and PR.ID_customer = $CookieID_customer
            ORDER BY PR.id
    
            ");


        // 2. Show PO
        $po_masters = DB::select("
        
            SELECT PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode, 
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode, 
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status, PO.payment_image,
                CUS.customer_type, CUS.shipping_type, CUS.payment_type, CUS.email,

                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by, PO.Shipping_ref, 
                PO.Shipping_date, PO.Shipping_emp, PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,PO.updated_at     
    

            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id          
              and PO.ID_customer = $CookieID_customer                        
            
        ");
        // 1. Show Customer Profile
        $this->get_configuration();
        $customer = customer::where('id', '=', Cookie::get('customer_id'))->get();

        return view( 'wholesale.wholesale_Add_PO', [
            'sess_grandparent_categories' => $this->grandparent_categories(),
            'sess_sub_categories' => $this->sub_categories(),
            'sess_categorie' => $this->sub_concat_categories(),
            'sess_categorie_short' => $this->categories(),
            'product_list20' => $this->categories(),
            'arr_configuration' => $this->get_configuration(),
            'po_masters' => $po_masters,
            'pr_list' => $pr_list,            
            'customer' => $customer,
            'ID_customer' => $CookieID_customer,            
            'po_mastermain' => $this->get_po_master($CookieID_customer)
        ]);

    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }


    public function downloadPDF($id)
    {
        $po_master = DB::select("    
            SELECT
                PO.PO_date, PO.id, PO.PO_Number, PO.ID_customer, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by,
                PO.Shipping_ref, PO.Shipping_date, PO.Shipping_emp,
                PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,
                CUS.customer_type, CUS.payment_type, CUS.email,CUS.flname, CUS.mobile, CUS.email
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.id = $id          
        ");

        foreach ($po_master as $data) {
            $PO_Number = $data->PO_Number;
        }
        $po_items = DB::select("    
            SELECT
              POI.PO_Number, POI.id, POI.ID_product, POI.product_color, POI.product_name_th,
              POI.Quantity, POI.final_price, POI.total, POI.product_unit, PD.ID_reference
            FROM po_items POI,products PD
            where POI.ID_product=PD.id
            and POI.PO_Number = '$PO_Number'
        ");

        $pdf = PDF::loadView('PO.PO_doc', compact('po_master',' po_items'));
        return $pdf->download($PO_Number. ' .pdf');
    }

    public function pdfview($id)
    {
        $id_PO = $id;
        $po_master = DB::select("    
            SELECT
                PO.PO_date, PO.id, PO.PO_Number, PO.ID_customer, PO.delivery_from, PO.delivery_end, PO.payment,
                PO.shipping_type, PO.company, PO.ID_tag,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by,
                PO.Shipping_ref, PO.Shipping_date, PO.Shipping_emp,
                PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,
                CUS.customer_type, CUS.payment_type, CUS.email,CUS.flname, CUS.mobile, CUS.email
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.id = $id_PO          
        ");

        foreach ($po_master as $data) {
            $PO_Number = $data->PO_Number;
        }

        $po_items = DB::select("    
            SELECT
              POI.PO_Number, POI.id, POI.ID_product, POI.product_color, POI.product_name_th,
              POI.Quantity, POI.final_price, POI.total, POI.product_unit, PD.ID_reference
            FROM po_items POI,products PD
            where POI.ID_product=PD.id
            and POI.PO_Number = '$PO_Number'
        ");
        return view('PO.PO_doc')
            ->with(compact('po_items'))
            ->with(compact('po_master'));
    }

    
    public function display_list_product_3(Request $request)
    {
        $input_search_product = $request->get('input_search_product');
        $input_search_categorie = $request->get( 'input_search_categorie');
        
        // dd( $input_search_product );
        $product_list = DB::table('products')
            ->where('product_name_th', 'like', "%$input_search_product%")
           // ->orwhere('ID_reference', 'like', "% $input_search_product %")
            ->where( 'ID_categories', 'like', "%$input_search_categorie%")                     
            ->join('products_categories', 'products.ID_categories', '=', 'products_categories.id')
            ->select(
                'products.id','products.ID_reference',
                'products_categories.categories',
                'products.product_name_th',
                'products.description_brief',
                'products.product_unit',
                'products.picture_path',
                'products.description',
                'products.wholesale_discount',
                'products.product_color',
                'products.wholesale_price',
                'products.shipping_weight',
                'products.wholesale_price',
                'products.wholesale_discount',
                'products.wholesale_discount_percent',                                                                            

                \DB::raw('(case
                WHEN wholesale_discount_dateStart <= now()
                and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                THEN wholesale_price - wholesale_discount
                else wholesale_price
                END) as wholesale_update_final_price'))
            ->get();  
            //->paginate(5);
        
        echo " <span class=\"badge badge-light\"> <h5> ผลการค้นหา :  </h5></span><br> ";    
        echo " <span class=\"badge badge-light\"> <h5> คำว่า “".$input_search_product."”  ทั้งหมด ". $product_list->count()."  รายการ </h5></span> ";

        return view( 'wholesale.display_list_product_4')
            ->with(compact('product_list'));
    }

    public function Add_Modal_Card_3(Request $request)
    {

        $ID_for_Add = $request->get( 'ID_for_Add');

        $product_view = DB::select("
            SELECT
                pc.id as id_categorie, pc.categories, pc.categories_parent,
                p.id, p.product_name_th, p.shipping_weight, p.picture_path, p.ID_reference,  p.description_brief,  p.description,
                p.wholesale_price, p.wholesale_discount, p.product_unit, p.product_color, p.wholesale_discount_percent, wholesale_final_price, 
                 
                case
                    WHEN wholesale_discount_dateStart <= now()
                    and DATE_ADD(wholesale_discount_dateEnd, INTERVAL 1 DAY) >= now()
                    THEN wholesale_price - wholesale_discount
                    else wholesale_price
                END as wholesale_update_final_price

                FROM products p, products_categories pc
                where p.ID_categories=pc.id
                and p.id= ' $ID_for_Add'
        ");

        return view( 'wholesale.Add_Modal_Card_4', [
            'arr_configuration' => $this->get_configuration(),
            'product_view' => $product_view


        ]);

    }

       
    public function Add_Cart_wholesale(Request $request)
    {
       // ตรวจ คน
        $customer_id = $request->get('ID_customer');
        if ($customer_id != '') {


            $product_color = $request->get('product_color');

            if ($product_color == '') {
                $product_color = 'NA';
            }
            
            // ตรวจว่าเคยสั่งรายการนี้ไหม
            $chk_Quantity = pr::where('ID_customer', '=', $customer_id)
                ->where('ID_product', '=', $request->get('ID_product'))
                ->where('product_color', '=', $product_color)
                ->get();

            $has_old_data = false;
            $old_Quantity = 0;
            if (count($chk_Quantity) > 0) {
                foreach ($chk_Quantity as $data) {
                    $old_Quantity = $data->Quantity;
                    $ID_pr = $data->id;
                }
                $has_old_data = true;
            }
            $sum_Quantity = $old_Quantity + $request->get('quantity_input');

          
            if ($has_old_data) {
                // Update
                $new_pr = pr::find($ID_pr);
                $new_pr->Quantity = $sum_Quantity;
                $new_pr->save();
            } else {
                // จะไม่พูดถึงราคาที่นี่ 
                $new_pr = new pr([
                    'Customer_Select' => 'ON',                    
                    'ID_customer' => $customer_id,
                    'ID_product' => $request->ID_product,
                    'product_color' => $product_color,
                    'Quantity' => $sum_Quantity,
                    'ip' => $this->get_client_ipmain()
                ]);
                $new_pr->save();
            }

            ////////////////////////////////////////////////
            //Store items in session
            ////////////////////////////////////////////////
            // session(['ID_product_NOW' => $request->ID_product]);
            // session(['product_color_NOW' => $product_color]);
            // session(['Quantity_NOW' => $sum_Quantity]);
            // session(['path_pic_NOW' => $customer_id]);

        } else {
            // เรียก Login Modal :::
        }

    }


    public function PO_doc(Request $request)
    {
        $id_PO = $request->get('id');
        $po_master = DB::select("    
            SELECT
                PO.PO_date, PO.id, PO.PO_Number, PO.ID_customer, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
                PO.shipping_type, PO.company,
                PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
                PO.billing_telephone,
                PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
                PO.shipping_telephone,
                PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
                PO.Packaging_status, PO.Packaging_date, PO.Packaging_emp, PO.Shipping_by,
                PO.Shipping_ref, PO.Shipping_date, PO.Shipping_emp,
                PO.GoodsReceipt_status, PO.GoodsReceipt_date, PO.GoodsReceipt_emp,
                CUS.customer_type, CUS.payment_type, CUS.email,CUS.flname, CUS.mobile, CUS.email
            FROM  po_masters PO, customers CUS
            where PO.ID_customer = CUS.id
              and PO.id = $id_PO          
        ");

        //    $Packaging = configuration::where('configuration_name', '=', 'Packaging')->get();
        //    $Shipping = configuration::where('configuration_name', '=', 'Shipping')->get();
        //    $GoodsReceipt = configuration::where('configuration_name', '=', 'GoodsReceipt')->get(); 

        // $po_master = po_master::where('id', '=', $request->get('id'))->get();       
        return view('PO.PO_doc')
            ->with(compact('po_master'));
        //      ->with(compact('Packaging'))
        //      ->with(compact('Shipping'))
        //      ->with(compact('GoodsReceipt'));
    }

}
