<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;
use DB;

class Order_Confirmed2 extends Mailable
{
    use Queueable, SerializesModels;
   // public $id;

    public $po;
    public $path_image_product;
    public $path_image_system; //1

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($po, $path_image_product,$path_image_system) //2
    {
        $this->po               = $po;
        $this->path_image_product = $path_image_product;
        $this->path_image_system =  $path_image_system;    //3
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
      //    - ส่ง Email หาลูกค้า
      $po_masters = DB::select("
          SELECT PO.id, PO.PO_Number, PO.ID_customer, PO.PO_date, PO.delivery_from, PO.delivery_end, PO.payment, PO.ID_tag,
              PO.shipping_type, PO.company,
              PO.billing_flname, PO.billing_address, PO.billing_city, PO.billing_province, PO.billing_zipcode,
              PO.billing_telephone,
              PO.shipping_flname, PO.shipping_address, PO.shipping_city, PO.shipping_province, PO.shipping_zipcode,
              PO.shipping_telephone,
              PO.weight, PO.po_shipping_charge, PO.total, PO.po_grandtotal, PO.Quantity, PO.po_status,
              CUS.customer_type, CUS.payment_type, CUS.email, CUS.flname
          FROM  po_masters PO, customers CUS
          where PO.ID_customer = CUS.id
              and PO.PO_Number = '$this->po'
      ");

      //ส่งรายการสั่งซื้อไปแสดงด้วย
      $po_items = DB::select("
              SELECT PO_Number, po_items.ID_product, products.ID_reference, po_items.product_color, po_items.ID_customer,
                    po_items.product_name_th, products.picture_path ,po_items.final_price, po_items.Quantity
              FROM po_items, products
              where
                  po_items.ID_product = products.id
              and po_items.PO_Number ='$this->po'
      ");

        return $this->view('Email.Order_Confirmed3')
          ->with('po_masters', $po_masters)
          ->with('po_items', $po_items)
          ->subject("ยืนยันคำสั่งซื้อหมายเลข #".$this->po);
    }



}
