@extends('layouts.customer')
@section('site_title')
รายการสั่งซื้อของฉัน ซื้อสินค้าออนไลน์ ราคาถูก ทั้งปลีก และส่ง 
@stop
@section('header_function')

<?php

    function DateThai_NotYear($strDate)
    {
        //  $strYear = date("Y", strtotime($strDate)) + 543;
        $strMonth = date("n", strtotime($strDate));
        $strDay = date("j", strtotime($strDate));
        $strHour = date("H", strtotime($strDate));
        $strMinute = date("i", strtotime($strDate));
        $strSeconds = date("s", strtotime($strDate));
        $strMonthCut = array("", "ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค.");
        $strMonthThai = $strMonthCut[$strMonth];
        return "$strDay $strMonthThai";  // $strYear $strHour:$strMinute
    }

    function DateThai2($strDate)
    {
        $strYear = date("Y", strtotime($strDate)) + 543;
        $strMonth = date("n", strtotime($strDate));
        $strDay = date("j", strtotime($strDate));
        $strHour = date("H", strtotime($strDate));
        $strMinute = date("i", strtotime($strDate));
        $strSeconds = date("s", strtotime($strDate));
        $strMonthCut = array("", "ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค.");
        $strMonthThai = $strMonthCut[$strMonth];
        return "$strDay $strMonthThai $strYear $strHour:$strMinute";  //
    }

    if ($nday=="") {
        $nday=7;
    }

    switch ($nday) {
    case 7:
        $ndayvalue = "1 สัปดาห์ที่ผ่านมา";
        break;
    case 31:
        $ndayvalue = "1 เดือนวันที่ผ่านมา";
        break;
    case 93:
        $ndayvalue = "3 เดือนวันที่ผ่านมา";
        break;
    case 183:
        $ndayvalue = "6 เดือนวันที่ผ่านมา";
        break;
    case 365:
        $ndayvalue = "1 ปีที่ผ่านมา";
        break;
    case 1825:
        $ndayvalue = "ทั้งหมด";
        break;
    default:
        $ndayvalue = "1 เดือนวันที่ผ่านมา";
    }

?>

@stop

@section('info')
  <br>
  <h4 class="title">รายการสั่งซื้อของฉัน </h4>

  <form class="form-inline" id="validationform" method="get" action="{{ url('customer_order') }}" data-parsley-validate="" novalidate="">
      <div class="form-group mx-sm-1 mb-0">
          <br> <br>
          <P STYLE="align:center">

                  {{ $po_masters->links() }}

          </p>
      </div>

      <div class="form-group mx-sm-5 mb-1">
          แสดง   &nbsp;&nbsp;
          <select name="nday" class="form-control text-secondary" id="nday">
              <option value="7"> 1 สัปดาห์ที่ผ่านมา </option>
              <option value="15"> 2 สัปดาห์ที่ผ่านมา</option>
              <option value="31"> 1 เดือนวันที่ผ่านมา </option>
              <option value="93"> 3 เดือนวันที่ผ่านมา </option>
              <option value="183"> 6 เดือนวันที่ผ่านมา </option>
              <option value="365"> 1 ปีที่ผ่านมา </option>
              <option value="1825"> ทั้งหมด </option>
              <option value="{{$nday}}" selected> {{$ndayvalue}}</option>
          </select>
      </div>

      <div class="form-group mx-sm-1 mb-1">
          <button type="submit" class="btn btn-secondary" id="display_list_product_1">
              <i class="fa fa-search" aria-hidden="true"></i> ค้นหา
          </button>
      </div>

      <div class="form-group mx-sm-1 mb-1">
      <!-- {{--  <span class="badge badge-warning">
          คำว่า "{{$input_search_name}}" + "{{$input_type}}"
          พบทั้งหมด {{$customers->total()}}  รายการ   </span>

      </div>     --}} -->
    </div>
  </form>


  <div class="table-responsive">
      <table class="table table-sm"  style="width:100%">
          <thead>
              <tr bgcolor="#4B515D">
                  <th align="center" class="text-light">คำสั่งซื้อ   </th>
                  <th align="center" class="text-light">  ยอดรวม  </th>
                  <th align="center" class="text-light"> การจัดส่ง   </th>
                  <th align="center" class="text-light"> สถานะ </th>
                  <th align="center" class="text-light"> จัดการคำสั่งซื้อ </th>
              </tr>
          </thead>
          <tbody>

          @foreach($po_masters as $po_master)
            <tr>
              <td> <a href="https://winnerprize.co.th/public/PO_view/{{$po_master->PO_Number}}">
                    #{{$po_master->PO_Number }} </a>
                <br>
                <p class="text-secondary">{{ $po_master->PO_date }}</p>
              </td>
              <td>
                ({{ $po_master->Quantity }} ชิ้น) <br>
                  <?php
                    echo number_format($po_master->po_grandtotal, 2, ".", ",");
                    if ($po_master->payment_image != "") {
                      echo " <br> ";
                      echo " <a class=\"image-link\" href=\" " . $arr_configuration[5] . $po_master->payment_image . " \"> ";
                      echo " <p class=\"text-secondary\"> ชำระเงินแล้ว </p>";
                      echo " </a>";
                    }
                  ?>
                </a>
              </td>
              <td> {{ $po_master->shipping_type }}<br>
                <?php
                  echo DateThai_NotYear($po_master->delivery_from) . " ถึง " . DateThai_NotYear($po_master->delivery_end);
                ?>
              </td>
              <td>
                  <?php
                    if ($po_master->po_status == 8) {
                      echo " <span class=\"badge badge-info\"> การยกเลิกใบสั่งซื้อ </span><br>";
                      echo $po_master->cancel_comment."<br>";
                      echo DateThai2($po_master->cancel_date);
                    }else if ($po_master->GoodsReceipt_emp != "") {
                      echo " <span class=\"badge badge-success\">" . $po_master->GoodsReceipt_status . "</span><br>";
                      echo DateThai2($po_master->GoodsReceipt_date);
                    }else if ($po_master->Shipping_emp != "") {
                      echo " <span class=\"badge badge-info\"> สินค้าอยู่ในระหว่างการจัดส่ง </span><br>";
                      echo "$po_master->Shipping_by ".DateThai2($po_master->Shipping_date);
                    }else if ($po_master->Packaging_emp != "") {
                      echo " <span class=\"badge badge-primary\">" . $po_master->Packaging_status . "</span><br>";
                      echo DateThai2($po_master->Packaging_date);
                    }else{
                      echo " <span class=\"badge badge-primary\"> ใบสั่งซื้ออยู่ในระว่างการดำเนินการ </span><br>";
                      echo DateThai2($po_master->updated_at);
                    }
                  ?>
              </td>
                  <td>
                      <div align="center">
                          <a href="{{ action('CustomerController@downloadPDF', ['id' => $po_master->id]) }}" target="_parent"> <i class="fa fa-file-pdf-o" aria-hidden="true"></i> </a>
                          &nbsp;&nbsp;
                          <a href="{{ action('CustomerController@pdfview', ['id' => $po_master->id]) }}" target="_blank"> <i class="fa fa-print" aria-hidden="true"></i> </a>
                      </div>

                      {{--1.1 Button --}}
                      @if ( ($po_master->po_status=="1") || ($po_master->po_status=="2") || ($po_master->po_status=="3")  )
                        <div align="center">
                            <button type="button" class="btn btn-link" id="{{$po_master->id }}" data-toggle="modal" data-target="#Modal_cancel_PO"
                            data-whatever="{{$po_master->id }}" > ยกเลิก </button>
                        </div>
                      @endif
                  </td>
            </tr>

          @endforeach

          </tbody>
          <tfoot>
              <tr>
                  <th colspan="5">
                    <P STYLE="align:center">
                        <div class="text-secondary">
                            {{ $po_masters->links() }}
                        </div>
                    </p>
                  </th>
              </tr>
          </tfoot>
    </table>
  </div>




        <!-- ============================================================== -->
        <!--  Modal_cancel_PO        -->
        <!-- ============================================================== -->
        <div class="modal fade" id="Modal_cancel_PO" tabindex="-1" role="dialog" aria-labelledby="Modal_cancel_POLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h3 class="modal-title" id="Modal_cancel_POLabel"> ยกเลิกใบคำสั่งซื้อ </h3>

                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times; </span>
                        </button>
                    </div>
                    <div class="modal-body">

                        <form class="contact">

                            <div class="form-group row">
                                <label class="col-12 col-sm-3 col-form-label text-sm-right">สาเหตุการยกเลิก *</label>
                                <div class="col-12 col-sm-8 col-lg-6">
                                    <input data-parsley-type="alphanum" id="cancel_comment" name="cancel_comment" type="text" required="" placeholder="" value="" class="form-control">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-12 col-sm-3 col-form-label text-sm-right"></label>
                                <div class="col-12 col-sm-8 col-lg-6">
                                    <p>
                                    <b>ยกเลิกคำสั่งซื้อ</b><br>
                                    1. ลูกค้าสามารถทำการยกเลิกคำสั่งซื้อได้ก่อนการจัดส่งสินค้า
                                       โปรดติดต่อศูนย์บริการลูกค้า ในเวลาทำการ (วันจันทร์ - วันศุกร์ เวลา 9.00 น. - 18.00 น.)
                                       หรือ อีเมล winnerprize@winnerprize.co.th <br>
                                    2. การคืนเงิน(ถ้ามี) เป็นไปตามข้อกำหนดบริษัทฯ <br>
                                    3. การยกเลิกสินค้าต้องระบุสาเหตุการยกเลิกให้ชัดเจน
                                    </p>
                                </div>
                            </div>
                            <div class="modal-body edit-content">
                            </div>

                        </form>

                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="submitModal_cancel_PO">ส่งใบยกเลิก</button>
                        <a href="#" class="btn" data-dismiss="modal">Close</a>
                    </div>
                </div>
            </div>
        </div>

@stop


@section('customer_footer')
    <script type="text/javascript">

		$.ajaxSetup({
			headers: {
				'X-CSRF-Token': $('meta[name="csrf_token"]').attr('content')
			}
		});

		var ID_for_Edit;

        //<!-- ============================================================== -->
        //<!--  Save Modal_cancel_PO     -->
        //<!-- ============================================================== -->
        $("button#submitModal_cancel_PO").click(function () {
            console.log($('form.contact').serialize());
            //alert(ID_for_Edit);
            $.ajax({
                type: "POST",
                url: "cancel_po",
                data: {cancel_comment: $("#cancel_comment").val(),  id: ID_for_Edit},
                success: function (msg) {
                    //$("#thanks").html(msg)
                    $("#Modal_cancel_PO").modal('hide');
                },
                error: function () {
                    alert("failure");
                }
            });
        });

        $('#Modal_cancel_PO').on('show.bs.modal', function(e) {

            var $modal = $(this),
            esseyId = e.relatedTarget.id;
			ID_for_Edit = e.relatedTarget.id;
			$modal.find('.edit-content').html();
        })


    </script>

@stop
