@extends('layouts.input')
@section('site_title', ' รายการ พนักงาน ')
@section('content')


<!-- ============================================================== -->
<!-- breadcrumb    -->
<!-- ============================================================== -->
<div class="container">
    <div class="row">
        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-12">
            <div class="page-header">
                <h2 class="pageheader-title">employees</h2>
                <p class="pageheader-text">Proin placerat ante duiullam scelerisque a velit ac porta, fusce sit amet vestibulum mi. Morbi lobortis pulvinar quam.</p>
                <div class="page-breadcrumb">
                    <nav aria-label="breadcrumb">
                        <ol class="breadcrumb">
                            <li class="breadcrumb-item"><a href="#" class="breadcrumb-link">Administration</a></li>
                            <li class="breadcrumb-item"><a href="#" class="breadcrumb-link">Employees</a></li>
                            <li class="breadcrumb-item active" aria-current="page">List All</li>
                        </ol>
                    </nav>
                </div>
            </div>
        </div>
    </div>
</div>


<form id="validationform" method="post" action="{{ url('employee') }}" data-parsley-validate="" novalidate="">
    {{csrf_field() }}
    <div class="container">
        <div class="row">
            <!-- ============================================================== -->
            <!-- valifation types -->
            <!-- ============================================================== -->
            <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-12">
                <div class="card">
                    <!--  <h5 class="card-header">Validation Types</h5> -->
                    <div class="card-body">
                        <!-- ตรวจสอบ Error การ Key ข้อมูล -->
                        @if(count($errors)>0)
                            <div class="alert alert-danger">
                            <ul>
                                @foreach($errors->all() as $error)
                                    <li>{{$error}}</li>
                                @endforeach
                            </ul>
                            </div>
                        @endif
                        @if(\Session::has('success'))
                            <div class="alert alert-success">
                            <p>{{ \Session::get('success') }} </p>
                            </div>
                        @endif
                        <!-- จบการตรวจสอบ ข้อมูล -->

                        <div class="form-group row">
                            <label class="col-12 col-sm-3 col-form-label text-sm-right">รหัสพนักงาน * </label>
                            <div class="col-12 col-sm-8 col-lg-6">
                                <input data-parsley-type="alphanum" name="employee_reference" type="text" required="" placeholder=" " value="" class="form-control">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-12 col-sm-3 col-form-label text-sm-right">ชื่อ * </label>
                            <div class="col-12 col-sm-8 col-lg-6">
                                <input data-parsley-type="alphanum" name="fname" type="text" required="" placeholder=" " value="" class="form-control">
                            </div>
                        </div>


                        <div class="form-group row">
                            <label class="col-12 col-sm-3 col-form-label text-sm-right">นามสกุล  * </label>
                            <div class="col-12 col-sm-8 col-lg-6">
                                <input data-parsley-type="alphanum" name="lname" type="text" required="" placeholder=" " value="" class="form-control">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-12 col-sm-3 col-form-label text-sm-right">Mobile</label>
                            <div class="col-12 col-sm-8 col-lg-6">
                                <input data-parsley-type="alphanum" name="mobile" type="text" required="" placeholder=" " value="" class="form-control">
                            </div>
                        </div>

                        <div class="form-group row">
                            <label class="col-12 col-sm-3 col-form-label text-sm-right">Profile Permission * </label>
                            <div class="col-12 col-sm-8 col-lg-6">

                                <select name="ID_permission" class="form-control" id="sel1">
                                    <option>1 = SuperAdmin</option>
                                    <option>2 = Administrator</option>
                                    <option>3 = Salesman</option>

                                </select>
                            </div>
                        </div>



                    </div>
                </div>
            </div>
            <!-- ============================================================== -->
            <!-- end valifation types -->
            <!-- ============================================================== -->


            <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-12">
                <div class="card">
                        <h5 class="card-header">Login</h5>
                    <div class="card-body">

                            <div class="form-group row">
                                <label class="col-12 col-sm-3 col-form-label text-sm-right">Email address</label>
                                <div class="col-12 col-sm-8 col-lg-6">
                                    <input id="inputEmail" name="email" type="email" placeholder="name@example.com" class="form-control">
                                </div>
                            </div>

                            <div class="form-group row">
                                <label class="col-12 col-sm-3 col-form-label text-sm-right">Password</label>
                                <div class="col-12 col-sm-8 col-lg-6">
                                    <input id="inputPassword" name="password" type="password" placeholder="Password" class="form-control">
                                </div>
                            </div>

                    </div>
                </div>
            </div>

        </div>

        <div class="form-group row">
            <label class="col-12 col-sm-3 col-form-label text-sm-right">สามารถใช้งานได้หรือไม่</label>
            <div class="col-12 col-sm-8 col-lg-6 pt-1">
                <label class="custom-control custom-radio custom-control-inline">
                    <input type="radio" name="enable"   class="custom-control-input" value="ON">
                    <span class="custom-control-label"> ใช้งานอยู่ </span>
                </label>
                <label class="custom-control custom-radio custom-control-inline">
                    <input type="radio" name="enable"   class="custom-control-input" value="OFF">
                    <span class="custom-control-label">ปิดการทำงาน</span>
                </label>
            </div>
        </div>

        <div class="form-group row text-right">
            <div class="col col-sm-10 col-lg-9 offset-sm-1 offset-lg-0">
                <button type="submit" class="btn btn-space btn-primary">Submit</button>
                <button class="btn btn-space btn-secondary">Cancel</button>
            </div>
        </div>

    </div>

</form>


@stop
